/* application.c generated by valac 0.56.17, the Vala compiler
 * generated from application.vala, do not modify */

/*
Peek Copyright (c) 2015-2020 by Philipp Wolfer <ph.wolfer@gmail.com>

This file is part of Peek.

This software is licensed under the GNU General Public License
(version 3 or later). See the LICENSE file in this distribution.
*/

#include "../../application.h"
#include <gtk/gtk.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <glib/gi18n-lib.h>
#include <stdio.h>
#include <keybinder-3.0/keybinder.h>
#include <gdk/gdk.h>

#define PEEK_APPLICATION_GTK_STYLE_PROVIDER_PRIORITY_APPLICATION ((guint) 600)
#define PEEK_APP_ID "com.uploadedlobster.peek"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define PEEK_UI_TYPE_APPLICATION_WINDOW (peek_ui_application_window_get_type ())
#define PEEK_UI_APPLICATION_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PEEK_UI_TYPE_APPLICATION_WINDOW, PeekUiApplicationWindow))
#define PEEK_UI_APPLICATION_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PEEK_UI_TYPE_APPLICATION_WINDOW, PeekUiApplicationWindowClass))
#define PEEK_UI_IS_APPLICATION_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PEEK_UI_TYPE_APPLICATION_WINDOW))
#define PEEK_UI_IS_APPLICATION_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PEEK_UI_TYPE_APPLICATION_WINDOW))
#define PEEK_UI_APPLICATION_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PEEK_UI_TYPE_APPLICATION_WINDOW, PeekUiApplicationWindowClass))

typedef struct _PeekUiApplicationWindow PeekUiApplicationWindow;
typedef struct _PeekUiApplicationWindowClass PeekUiApplicationWindowClass;
enum  {
	PEEK_APPLICATION_0_PROPERTY,
	PEEK_APPLICATION_KEYBINDING_TOGGLE_RECORDING_PROPERTY,
	PEEK_APPLICATION_NUM_PROPERTIES
};
static GParamSpec* peek_application_properties[PEEK_APPLICATION_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_variant_dict_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_dict_unref (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
enum  {
	PEEK_APPLICATION_TOGGLE_RECORDING_SIGNAL,
	PEEK_APPLICATION_START_RECORDING_SIGNAL,
	PEEK_APPLICATION_STOP_RECORDING_SIGNAL,
	PEEK_APPLICATION_NUM_SIGNALS
};
static guint peek_application_signals[PEEK_APPLICATION_NUM_SIGNALS] = {0};

struct _PeekApplicationPrivate {
	PeekUiApplicationWindow* main_window;
	gchar* _keybinding_toggle_recording;
};

static gint PeekApplication_private_offset;
static gpointer peek_application_parent_class = NULL;
static GSettings* peek_application_settings;
static GSettings* peek_application_settings = NULL;
static gboolean peek_application__keybindings_paused;
static gboolean peek_application__keybindings_paused = FALSE;

VALA_EXTERN GType peek_ui_application_window_get_type (void) G_GNUC_CONST ;
static void peek_application_real_activate (GApplication* base);
static void peek_application_new_window (PeekApplication* self);
static void peek_application_real_startup (GApplication* base);
static void peek_application_load_stylesheets (void);
static void peek_application_register_actions (PeekApplication* self);
static void peek_application_register_key_bindings (PeekApplication* self);
static void peek_application_real_shutdown (GApplication* base);
VALA_EXTERN PeekRecordingScreenRecorder* peek_ui_application_window_get_recorder (PeekUiApplicationWindow* self);
static void peek_application_unregister_key_bindings (PeekApplication* self);
static gint peek_application_real_handle_local_options (GApplication* base,
                                                 GVariantDict* options);
static gint peek_application_real_command_line (GApplication* base,
                                         GApplicationCommandLine* command_line);
VALA_EXTERN void peek_ui_application_window_hide_headerbar (PeekUiApplicationWindow* self);
static void _peek_application_new_window_g_simple_action_activate (GSimpleAction* _sender,
                                                            GVariant* parameter,
                                                            gpointer self);
static void peek_application_new_window_with_backend (PeekApplication* self,
                                               GVariant* backend);
static void _peek_application_new_window_with_backend_g_simple_action_activate (GSimpleAction* _sender,
                                                                         GVariant* parameter,
                                                                         gpointer self);
static void peek_application_set_window_size (PeekApplication* self);
static void _peek_application_set_window_size_g_simple_action_activate (GSimpleAction* _sender,
                                                                 GVariant* parameter,
                                                                 gpointer self);
static void peek_application_show_preferences (PeekApplication* self);
static void _peek_application_show_preferences_g_simple_action_activate (GSimpleAction* _sender,
                                                                  GVariant* parameter,
                                                                  gpointer self);
static void peek_application_show_about (PeekApplication* self);
static void _peek_application_show_about_g_simple_action_activate (GSimpleAction* _sender,
                                                            GVariant* parameter,
                                                            gpointer self);
static void _peek_application_request_quit_g_simple_action_activate (GSimpleAction* _sender,
                                                              GVariant* parameter,
                                                              gpointer self);
static void peek_application_show_file (PeekApplication* self,
                                 GVariant* uri);
static void _peek_application_show_file_g_simple_action_activate (GSimpleAction* _sender,
                                                           GVariant* parameter,
                                                           gpointer self);
static void peek_application_handle_keybinding_toggle_recording (PeekApplication* self,
                                                          const gchar* keystring);
static void peek_application_show_window (PeekApplication* self,
                                   PeekRecordingScreenRecorder* recorder);
static void peek_application_show_recording_backend_warning (PeekApplication* self,
                                                      const gchar* msg);
VALA_EXTERN GtkDialog* peek_ui_set_window_size_dialog_present_single_instance (PeekUiApplicationWindow* main_window);
static void peek_application_show_wayland_warning (PeekApplication* self);
VALA_EXTERN PeekUiApplicationWindow* peek_ui_application_window_new (PeekApplication* application,
                                                         PeekRecordingScreenRecorder* recorder);
VALA_EXTERN PeekUiApplicationWindow* peek_ui_application_window_construct (GType object_type,
                                                               PeekApplication* application,
                                                               PeekRecordingScreenRecorder* recorder);
VALA_EXTERN GtkWindow* peek_ui_preferences_dialog_present_single_instance (GtkWindow* main_window);
VALA_EXTERN GtkDialog* peek_ui_about_dialog_present_single_instance (GtkWindow* main_window);
static void peek_application_load_stylesheet_by_name (const gchar* name);
static void peek_application_load_stylesheet_from_uri (const gchar* uri);
static void peek_application_show_startup_warning (PeekApplication* self,
                                            const gchar* title,
                                            const gchar* text);
static void _peek_application_handle_keybinding_toggle_recording_keybinder_handler (const gchar* keystring,
                                                                             gpointer self);
static void peek_application_finalize (GObject * obj);
static GType peek_application_get_type_once (void);
static void _vala_peek_application_get_property (GObject * object,
                                          guint property_id,
                                          GValue * value,
                                          GParamSpec * pspec);
static void _vala_peek_application_set_property (GObject * object,
                                          guint property_id,
                                          const GValue * value,
                                          GParamSpec * pspec);

static inline gpointer
peek_application_get_instance_private (PeekApplication* self)
{
	return G_STRUCT_MEMBER_P (self, PeekApplication_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 29 "../src/application.vala"
	return self ? g_object_ref (self) : NULL;
#line 164 "application.c"
}

GSettings*
peek_application_get_app_settings (void)
{
	GSettings* _tmp0_;
	GSettings* _tmp3_;
	GSettings* _tmp5_;
	GSettings* _tmp6_;
	GSettings* result;
#line 28 "../src/application.vala"
	_tmp0_ = peek_application_settings;
#line 28 "../src/application.vala"
	if (_tmp0_ != NULL) {
#line 179 "application.c"
		GSettings* _tmp1_;
		GSettings* _tmp2_;
#line 29 "../src/application.vala"
		_tmp1_ = peek_application_settings;
#line 29 "../src/application.vala"
		_tmp2_ = _g_object_ref0 (_tmp1_);
#line 29 "../src/application.vala"
		result = _tmp2_;
#line 29 "../src/application.vala"
		return result;
#line 190 "application.c"
	}
#line 46 "../src/application.vala"
	_tmp3_ = peek_application_settings;
#line 46 "../src/application.vala"
	if (_tmp3_ == NULL) {
#line 196 "application.c"
		GSettings* _tmp4_;
#line 47 "../src/application.vala"
		_tmp4_ = g_settings_new (PEEK_APP_ID);
#line 47 "../src/application.vala"
		_g_object_unref0 (peek_application_settings);
#line 47 "../src/application.vala"
		peek_application_settings = _tmp4_;
#line 204 "application.c"
	}
#line 50 "../src/application.vala"
	_tmp5_ = peek_application_settings;
#line 50 "../src/application.vala"
	_tmp6_ = _g_object_ref0 (_tmp5_);
#line 50 "../src/application.vala"
	result = _tmp6_;
#line 50 "../src/application.vala"
	return result;
#line 214 "application.c"
}

PeekApplication*
peek_application_construct (GType object_type)
{
	PeekApplication * self = NULL;
#line 58 "../src/application.vala"
	self = (PeekApplication*) g_object_new (object_type, "application-id", PEEK_APP_ID, "flags", G_APPLICATION_HANDLES_COMMAND_LINE, NULL);
#line 61 "../src/application.vala"
	g_application_add_main_option ((GApplication*) self, "version", 'v', G_OPTION_FLAG_IN_MAIN, G_OPTION_ARG_NONE, _ ("Show the version of the program and exit"), NULL);
#line 65 "../src/application.vala"
	g_application_add_main_option ((GApplication*) self, "backend", 'b', G_OPTION_FLAG_IN_MAIN, G_OPTION_ARG_STRING, _ ("Select the recording backend (gnome-shell, ffmpeg)"), _ ("BACKEND"));
#line 70 "../src/application.vala"
	g_application_add_main_option ((GApplication*) self, "start", 's', G_OPTION_FLAG_IN_MAIN, G_OPTION_ARG_NONE, _ ("Start recording in all running Peek instances"), NULL);
#line 74 "../src/application.vala"
	g_application_add_main_option ((GApplication*) self, "stop", 'p', G_OPTION_FLAG_IN_MAIN, G_OPTION_ARG_NONE, _ ("Stop recording in all running Peek instances"), NULL);
#line 78 "../src/application.vala"
	g_application_add_main_option ((GApplication*) self, "toggle", 't', G_OPTION_FLAG_IN_MAIN, G_OPTION_ARG_NONE, _ ("Toggle recording in all running Peek instances"), NULL);
#line 82 "../src/application.vala"
	g_application_add_main_option ((GApplication*) self, "no-headerbar", (gchar) 0, G_OPTION_FLAG_IN_MAIN, G_OPTION_ARG_NONE, _ ("Start Peek without the header bar"), NULL);
#line 57 "../src/application.vala"
	return self;
#line 237 "application.c"
}

PeekApplication*
peek_application_new (void)
{
#line 57 "../src/application.vala"
	return peek_application_construct (PEEK_TYPE_APPLICATION);
#line 245 "application.c"
}

static void
peek_application_real_activate (GApplication* base)
{
	PeekApplication * self;
#line 87 "../src/application.vala"
	self = (PeekApplication*) base;
#line 88 "../src/application.vala"
	peek_application_new_window (self);
#line 256 "application.c"
}

static void
peek_application_real_startup (GApplication* base)
{
	PeekApplication * self;
#line 91 "../src/application.vala"
	self = (PeekApplication*) base;
#line 92 "../src/application.vala"
	G_APPLICATION_CLASS (peek_application_parent_class)->startup ((GApplication*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_application_get_type (), GtkApplication));
#line 93 "../src/application.vala"
	peek_application_load_stylesheets ();
#line 94 "../src/application.vala"
	g_set_application_name (_ ("Peek"));
#line 95 "../src/application.vala"
	peek_application_register_actions (self);
#line 98 "../src/application.vala"
	if (peek_desktop_integration_is_x11_backend ()) {
#line 99 "../src/application.vala"
		peek_application_register_key_bindings (self);
#line 277 "application.c"
	}
}

void
peek_application_request_quit (PeekApplication* self)
{
	GList* _tmp0_;
#line 104 "../src/application.vala"
	g_return_if_fail (self != NULL);
#line 105 "../src/application.vala"
	g_debug ("application.vala:105: Application was requested to quit");
#line 106 "../src/application.vala"
	_tmp0_ = gtk_application_get_windows ((GtkApplication*) self);
#line 291 "application.c"
	{
		GList* window_collection = NULL;
		GList* window_it = NULL;
#line 106 "../src/application.vala"
		window_collection = _tmp0_;
#line 106 "../src/application.vala"
		for (window_it = window_collection; window_it != NULL; window_it = window_it->next) {
#line 299 "application.c"
			GtkWindow* _tmp1_;
			GtkWindow* window = NULL;
#line 106 "../src/application.vala"
			_tmp1_ = _g_object_ref0 ((GtkWindow*) window_it->data);
#line 106 "../src/application.vala"
			window = _tmp1_;
#line 306 "application.c"
			{
				GtkWindow* _tmp2_;
#line 107 "../src/application.vala"
				_tmp2_ = window;
#line 107 "../src/application.vala"
				gtk_window_close (_tmp2_);
#line 106 "../src/application.vala"
				_g_object_unref0 (window);
#line 315 "application.c"
			}
		}
	}
}

static void
peek_application_real_shutdown (GApplication* base)
{
	PeekApplication * self;
	GList* _tmp0_;
#line 111 "../src/application.vala"
	self = (PeekApplication*) base;
#line 112 "../src/application.vala"
	g_debug ("application.vala:112: Application got shutdown signal");
#line 113 "../src/application.vala"
	_tmp0_ = gtk_application_get_windows ((GtkApplication*) self);
#line 332 "application.c"
	{
		GList* window_collection = NULL;
		GList* window_it = NULL;
#line 113 "../src/application.vala"
		window_collection = _tmp0_;
#line 113 "../src/application.vala"
		for (window_it = window_collection; window_it != NULL; window_it = window_it->next) {
#line 340 "application.c"
			GtkWindow* _tmp1_;
			GtkWindow* window = NULL;
#line 113 "../src/application.vala"
			_tmp1_ = _g_object_ref0 ((GtkWindow*) window_it->data);
#line 113 "../src/application.vala"
			window = _tmp1_;
#line 347 "application.c"
			{
				PeekRecordingScreenRecorder* recorder = NULL;
				GtkWindow* _tmp2_;
				PeekRecordingScreenRecorder* _tmp3_;
				PeekRecordingScreenRecorder* _tmp4_;
				PeekRecordingScreenRecorder* _tmp5_;
				PeekRecordingScreenRecorder* _tmp6_;
#line 114 "../src/application.vala"
				_tmp2_ = window;
#line 114 "../src/application.vala"
				_tmp3_ = peek_ui_application_window_get_recorder (PEEK_UI_IS_APPLICATION_WINDOW (_tmp2_) ? ((PeekUiApplicationWindow*) _tmp2_) : NULL);
#line 114 "../src/application.vala"
				_tmp4_ = _tmp3_;
#line 114 "../src/application.vala"
				_tmp5_ = _g_object_ref0 (_tmp4_);
#line 114 "../src/application.vala"
				recorder = _tmp5_;
#line 115 "../src/application.vala"
				_tmp6_ = recorder;
#line 115 "../src/application.vala"
				peek_recording_screen_recorder_cancel (_tmp6_);
#line 113 "../src/application.vala"
				_g_object_unref0 (recorder);
#line 113 "../src/application.vala"
				_g_object_unref0 (window);
#line 373 "application.c"
			}
		}
	}
#line 119 "../src/application.vala"
	peek_application_unregister_key_bindings (self);
#line 122 "../src/application.vala"
	G_APPLICATION_CLASS (peek_application_parent_class)->shutdown ((GApplication*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_application_get_type (), GtkApplication));
#line 381 "application.c"
}

static gint
peek_application_real_handle_local_options (GApplication* base,
                                            GVariantDict* options)
{
	PeekApplication * self;
	gint result;
#line 125 "../src/application.vala"
	self = (PeekApplication*) base;
#line 125 "../src/application.vala"
	g_return_val_if_fail (options != NULL, 0);
#line 126 "../src/application.vala"
	if (g_variant_dict_contains (options, "version")) {
#line 396 "application.c"
		FILE* _tmp0_;
#line 127 "../src/application.vala"
		_tmp0_ = stderr;
#line 127 "../src/application.vala"
		fprintf (_tmp0_, "%1$s %2$s\n", "Peek", VERSION);
#line 128 "../src/application.vala"
		result = EXIT_SUCCESS;
#line 128 "../src/application.vala"
		return result;
#line 406 "application.c"
	}
#line 131 "../src/application.vala"
	result = -1;
#line 131 "../src/application.vala"
	return result;
#line 412 "application.c"
}

static gpointer
_g_variant_dict_ref0 (gpointer self)
{
#line 135 "../src/application.vala"
	return self ? g_variant_dict_ref (self) : NULL;
#line 420 "application.c"
}

static gint
peek_application_real_command_line (GApplication* base,
                                    GApplicationCommandLine* command_line)
{
	PeekApplication * self;
	GVariantDict* options = NULL;
	GVariantDict* _tmp0_;
	GVariantDict* _tmp1_;
	GVariantDict* _tmp2_;
	GVariantDict* _tmp3_;
	GVariantDict* _tmp4_;
	GVariantDict* _tmp5_;
	gboolean _tmp10_ = FALSE;
	GVariantDict* _tmp11_;
	gint result;
#line 134 "../src/application.vala"
	self = (PeekApplication*) base;
#line 134 "../src/application.vala"
	g_return_val_if_fail (command_line != NULL, 0);
#line 135 "../src/application.vala"
	_tmp0_ = g_application_command_line_get_options_dict (command_line);
#line 135 "../src/application.vala"
	_tmp1_ = _g_variant_dict_ref0 (_tmp0_);
#line 135 "../src/application.vala"
	options = _tmp1_;
#line 136 "../src/application.vala"
	_tmp2_ = options;
#line 136 "../src/application.vala"
	if (g_variant_dict_contains (_tmp2_, "start")) {
#line 137 "../src/application.vala"
		g_signal_emit (self, peek_application_signals[PEEK_APPLICATION_START_RECORDING_SIGNAL], 0);
#line 138 "../src/application.vala"
		result = EXIT_SUCCESS;
#line 138 "../src/application.vala"
		_g_variant_dict_unref0 (options);
#line 138 "../src/application.vala"
		return result;
#line 460 "application.c"
	}
#line 141 "../src/application.vala"
	_tmp3_ = options;
#line 141 "../src/application.vala"
	if (g_variant_dict_contains (_tmp3_, "stop")) {
#line 142 "../src/application.vala"
		g_signal_emit (self, peek_application_signals[PEEK_APPLICATION_STOP_RECORDING_SIGNAL], 0);
#line 143 "../src/application.vala"
		result = EXIT_SUCCESS;
#line 143 "../src/application.vala"
		_g_variant_dict_unref0 (options);
#line 143 "../src/application.vala"
		return result;
#line 474 "application.c"
	}
#line 146 "../src/application.vala"
	_tmp4_ = options;
#line 146 "../src/application.vala"
	if (g_variant_dict_contains (_tmp4_, "toggle")) {
#line 147 "../src/application.vala"
		g_signal_emit (self, peek_application_signals[PEEK_APPLICATION_TOGGLE_RECORDING_SIGNAL], 0);
#line 148 "../src/application.vala"
		result = EXIT_SUCCESS;
#line 148 "../src/application.vala"
		_g_variant_dict_unref0 (options);
#line 148 "../src/application.vala"
		return result;
#line 488 "application.c"
	}
#line 151 "../src/application.vala"
	_tmp5_ = options;
#line 151 "../src/application.vala"
	if (g_variant_dict_contains (_tmp5_, "backend")) {
#line 494 "application.c"
		GVariant* backend = NULL;
		GVariantDict* _tmp6_;
		const GVariantType* _tmp7_;
		GVariant* _tmp8_;
		GVariant* _tmp9_;
#line 152 "../src/application.vala"
		_tmp6_ = options;
#line 152 "../src/application.vala"
		_tmp7_ = G_VARIANT_TYPE_STRING;
#line 152 "../src/application.vala"
		_tmp8_ = g_variant_dict_lookup_value (_tmp6_, "backend", _tmp7_);
#line 152 "../src/application.vala"
		backend = _tmp8_;
#line 153 "../src/application.vala"
		_tmp9_ = backend;
#line 153 "../src/application.vala"
		g_action_group_activate_action ((GActionGroup*) self, "new-window-with-backend", _tmp9_);
#line 151 "../src/application.vala"
		_g_variant_unref0 (backend);
#line 514 "application.c"
	} else {
#line 155 "../src/application.vala"
		g_action_group_activate_action ((GActionGroup*) self, "new-window", NULL);
#line 518 "application.c"
	}
#line 158 "../src/application.vala"
	_tmp11_ = options;
#line 158 "../src/application.vala"
	if (g_variant_dict_contains (_tmp11_, "no-headerbar")) {
#line 524 "application.c"
		PeekUiApplicationWindow* _tmp12_;
#line 158 "../src/application.vala"
		_tmp12_ = self->priv->main_window;
#line 158 "../src/application.vala"
		_tmp10_ = _tmp12_ != NULL;
#line 530 "application.c"
	} else {
#line 158 "../src/application.vala"
		_tmp10_ = FALSE;
#line 534 "application.c"
	}
#line 158 "../src/application.vala"
	if (_tmp10_) {
#line 538 "application.c"
		PeekUiApplicationWindow* _tmp13_;
#line 159 "../src/application.vala"
		_tmp13_ = self->priv->main_window;
#line 159 "../src/application.vala"
		peek_ui_application_window_hide_headerbar (_tmp13_);
#line 544 "application.c"
	}
#line 162 "../src/application.vala"
	result = EXIT_SUCCESS;
#line 162 "../src/application.vala"
	_g_variant_dict_unref0 (options);
#line 162 "../src/application.vala"
	return result;
#line 552 "application.c"
}

static void
_peek_application_new_window_g_simple_action_activate (GSimpleAction* _sender,
                                                       GVariant* parameter,
                                                       gpointer self)
{
#line 170 "../src/application.vala"
	peek_application_new_window ((PeekApplication*) self);
#line 562 "application.c"
}

static void
_peek_application_new_window_with_backend_g_simple_action_activate (GSimpleAction* _sender,
                                                                    GVariant* parameter,
                                                                    gpointer self)
{
#line 174 "../src/application.vala"
	peek_application_new_window_with_backend ((PeekApplication*) self, parameter);
#line 572 "application.c"
}

static void
_peek_application_set_window_size_g_simple_action_activate (GSimpleAction* _sender,
                                                            GVariant* parameter,
                                                            gpointer self)
{
#line 178 "../src/application.vala"
	peek_application_set_window_size ((PeekApplication*) self);
#line 582 "application.c"
}

static void
_peek_application_show_preferences_g_simple_action_activate (GSimpleAction* _sender,
                                                             GVariant* parameter,
                                                             gpointer self)
{
#line 182 "../src/application.vala"
	peek_application_show_preferences ((PeekApplication*) self);
#line 592 "application.c"
}

static void
_peek_application_show_about_g_simple_action_activate (GSimpleAction* _sender,
                                                       GVariant* parameter,
                                                       gpointer self)
{
#line 186 "../src/application.vala"
	peek_application_show_about ((PeekApplication*) self);
#line 602 "application.c"
}

static void
_peek_application_request_quit_g_simple_action_activate (GSimpleAction* _sender,
                                                         GVariant* parameter,
                                                         gpointer self)
{
#line 190 "../src/application.vala"
	peek_application_request_quit ((PeekApplication*) self);
#line 612 "application.c"
}

static void
_peek_application_show_file_g_simple_action_activate (GSimpleAction* _sender,
                                                      GVariant* parameter,
                                                      gpointer self)
{
#line 195 "../src/application.vala"
	peek_application_show_file ((PeekApplication*) self, parameter);
#line 622 "application.c"
}

static void
peek_application_register_actions (PeekApplication* self)
{
	GSimpleAction* action = NULL;
	GSimpleAction* _tmp0_;
	GSimpleAction* _tmp1_;
	GSimpleAction* _tmp2_;
	const GVariantType* _tmp3_;
	GSimpleAction* _tmp4_;
	GSimpleAction* _tmp5_;
	GSimpleAction* _tmp6_;
	GSimpleAction* _tmp7_;
	GSimpleAction* _tmp8_;
	GSimpleAction* _tmp9_;
	GSimpleAction* _tmp10_;
	GSimpleAction* _tmp11_;
	GSimpleAction* _tmp12_;
	GSimpleAction* _tmp13_;
	GSimpleAction* _tmp14_;
	GSimpleAction* _tmp15_;
	GSimpleAction* _tmp16_;
	GSimpleAction* _tmp17_;
	GSimpleAction* _tmp18_;
	const GVariantType* _tmp19_;
	GSimpleAction* _tmp20_;
	GSimpleAction* _tmp21_;
	GSimpleAction* _tmp22_;
#line 165 "../src/application.vala"
	g_return_if_fail (self != NULL);
#line 169 "../src/application.vala"
	_tmp0_ = g_simple_action_new ("new-window", NULL);
#line 169 "../src/application.vala"
	_g_object_unref0 (action);
#line 169 "../src/application.vala"
	action = _tmp0_;
#line 170 "../src/application.vala"
	_tmp1_ = action;
#line 170 "../src/application.vala"
	g_signal_connect_object (_tmp1_, "activate", (GCallback) _peek_application_new_window_g_simple_action_activate, self, 0);
#line 171 "../src/application.vala"
	_tmp2_ = action;
#line 171 "../src/application.vala"
	g_action_map_add_action ((GActionMap*) self, (GAction*) _tmp2_);
#line 173 "../src/application.vala"
	_tmp3_ = G_VARIANT_TYPE_STRING;
#line 173 "../src/application.vala"
	_tmp4_ = g_simple_action_new ("new-window-with-backend", _tmp3_);
#line 173 "../src/application.vala"
	_g_object_unref0 (action);
#line 173 "../src/application.vala"
	action = _tmp4_;
#line 174 "../src/application.vala"
	_tmp5_ = action;
#line 174 "../src/application.vala"
	g_signal_connect_object (_tmp5_, "activate", (GCallback) _peek_application_new_window_with_backend_g_simple_action_activate, self, 0);
#line 175 "../src/application.vala"
	_tmp6_ = action;
#line 175 "../src/application.vala"
	g_action_map_add_action ((GActionMap*) self, (GAction*) _tmp6_);
#line 177 "../src/application.vala"
	_tmp7_ = g_simple_action_new ("set-window-size", NULL);
#line 177 "../src/application.vala"
	_g_object_unref0 (action);
#line 177 "../src/application.vala"
	action = _tmp7_;
#line 178 "../src/application.vala"
	_tmp8_ = action;
#line 178 "../src/application.vala"
	g_signal_connect_object (_tmp8_, "activate", (GCallback) _peek_application_set_window_size_g_simple_action_activate, self, 0);
#line 179 "../src/application.vala"
	_tmp9_ = action;
#line 179 "../src/application.vala"
	g_action_map_add_action ((GActionMap*) self, (GAction*) _tmp9_);
#line 181 "../src/application.vala"
	_tmp10_ = g_simple_action_new ("preferences", NULL);
#line 181 "../src/application.vala"
	_g_object_unref0 (action);
#line 181 "../src/application.vala"
	action = _tmp10_;
#line 182 "../src/application.vala"
	_tmp11_ = action;
#line 182 "../src/application.vala"
	g_signal_connect_object (_tmp11_, "activate", (GCallback) _peek_application_show_preferences_g_simple_action_activate, self, 0);
#line 183 "../src/application.vala"
	_tmp12_ = action;
#line 183 "../src/application.vala"
	g_action_map_add_action ((GActionMap*) self, (GAction*) _tmp12_);
#line 185 "../src/application.vala"
	_tmp13_ = g_simple_action_new ("about", NULL);
#line 185 "../src/application.vala"
	_g_object_unref0 (action);
#line 185 "../src/application.vala"
	action = _tmp13_;
#line 186 "../src/application.vala"
	_tmp14_ = action;
#line 186 "../src/application.vala"
	g_signal_connect_object (_tmp14_, "activate", (GCallback) _peek_application_show_about_g_simple_action_activate, self, 0);
#line 187 "../src/application.vala"
	_tmp15_ = action;
#line 187 "../src/application.vala"
	g_action_map_add_action ((GActionMap*) self, (GAction*) _tmp15_);
#line 189 "../src/application.vala"
	_tmp16_ = g_simple_action_new ("quit", NULL);
#line 189 "../src/application.vala"
	_g_object_unref0 (action);
#line 189 "../src/application.vala"
	action = _tmp16_;
#line 190 "../src/application.vala"
	_tmp17_ = action;
#line 190 "../src/application.vala"
	g_signal_connect_object (_tmp17_, "activate", (GCallback) _peek_application_request_quit_g_simple_action_activate, self, 0);
#line 191 "../src/application.vala"
	_tmp18_ = action;
#line 191 "../src/application.vala"
	g_action_map_add_action ((GActionMap*) self, (GAction*) _tmp18_);
#line 194 "../src/application.vala"
	_tmp19_ = G_VARIANT_TYPE_STRING;
#line 194 "../src/application.vala"
	_tmp20_ = g_simple_action_new ("show-file", _tmp19_);
#line 194 "../src/application.vala"
	_g_object_unref0 (action);
#line 194 "../src/application.vala"
	action = _tmp20_;
#line 195 "../src/application.vala"
	_tmp21_ = action;
#line 195 "../src/application.vala"
	g_signal_connect_object (_tmp21_, "activate", (GCallback) _peek_application_show_file_g_simple_action_activate, self, 0);
#line 196 "../src/application.vala"
	_tmp22_ = action;
#line 196 "../src/application.vala"
	g_action_map_add_action ((GActionMap*) self, (GAction*) _tmp22_);
#line 165 "../src/application.vala"
	_g_object_unref0 (action);
#line 758 "application.c"
}

static void
peek_application_register_key_bindings (PeekApplication* self)
{
	GSettings* settings = NULL;
	GSettings* _tmp0_;
#line 201 "../src/application.vala"
	g_return_if_fail (self != NULL);
#line 202 "../src/application.vala"
	_tmp0_ = peek_application_get_app_settings ();
#line 202 "../src/application.vala"
	settings = _tmp0_;
#line 205 "../src/application.vala"
	keybinder_init ();
#line 206 "../src/application.vala"
	keybinder_set_use_cooked_accelerators (FALSE);
#line 208 "../src/application.vala"
	g_settings_bind (settings, "keybinding-toggle-recording", (GObject*) self, "keybinding_toggle_recording", G_SETTINGS_BIND_DEFAULT);
#line 201 "../src/application.vala"
	_g_object_unref0 (settings);
#line 780 "application.c"
}

static void
peek_application_unregister_key_bindings (PeekApplication* self)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
#line 213 "../src/application.vala"
	g_return_if_fail (self != NULL);
#line 214 "../src/application.vala"
	_tmp0_ = peek_application_get_keybinding_toggle_recording (self);
#line 214 "../src/application.vala"
	_tmp1_ = _tmp0_;
#line 214 "../src/application.vala"
	keybinder_unbind_all (_tmp1_);
#line 796 "application.c"
}

static void
peek_application_handle_keybinding_toggle_recording (PeekApplication* self,
                                                     const gchar* keystring)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 235 "../src/application.vala"
	g_return_if_fail (self != NULL);
#line 235 "../src/application.vala"
	g_return_if_fail (keystring != NULL);
#line 236 "../src/application.vala"
	_tmp0_ = peek_application_get_keybindings_paused ();
#line 236 "../src/application.vala"
	_tmp1_ = _tmp0_;
#line 236 "../src/application.vala"
	if (!_tmp1_) {
#line 237 "../src/application.vala"
		g_debug ("application.vala:237: Global keybinding %s\n", keystring);
#line 238 "../src/application.vala"
		g_signal_emit (self, peek_application_signals[PEEK_APPLICATION_TOGGLE_RECORDING_SIGNAL], 0);
#line 819 "application.c"
	}
}

static void
peek_application_new_window (PeekApplication* self)
{
	GError* _inner_error0_ = NULL;
#line 243 "../src/application.vala"
	g_return_if_fail (self != NULL);
#line 829 "application.c"
	{
		PeekRecordingScreenRecorder* recorder = NULL;
		PeekRecordingScreenRecorder* _tmp0_;
#line 245 "../src/application.vala"
		_tmp0_ = peek_recording_screen_recorder_factory_create_default_screen_recorder (&_inner_error0_);
#line 245 "../src/application.vala"
		recorder = _tmp0_;
#line 245 "../src/application.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 245 "../src/application.vala"
			if (_inner_error0_->domain == PEEK_PEEK_ERROR) {
#line 841 "application.c"
				goto __catch0_peek_peek_error;
			}
#line 245 "../src/application.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 245 "../src/application.vala"
			g_clear_error (&_inner_error0_);
#line 245 "../src/application.vala"
			return;
#line 850 "application.c"
		}
#line 246 "../src/application.vala"
		peek_application_show_window (self, recorder);
#line 244 "../src/application.vala"
		_g_object_unref0 (recorder);
#line 856 "application.c"
	}
	goto __finally0;
	__catch0_peek_peek_error:
	{
		GError* e = NULL;
		gchar* msg = NULL;
		GError* _tmp1_;
		const gchar* _tmp2_;
		gchar* _tmp3_;
		FILE* _tmp4_;
		const gchar* _tmp5_;
		const gchar* _tmp6_;
#line 244 "../src/application.vala"
		e = _inner_error0_;
#line 244 "../src/application.vala"
		_inner_error0_ = NULL;
#line 248 "../src/application.vala"
		_tmp1_ = e;
#line 248 "../src/application.vala"
		_tmp2_ = _tmp1_->message;
#line 248 "../src/application.vala"
		_tmp3_ = g_strdup_printf (_ ("Unable to initialize default recording backend: %s"), _tmp2_);
#line 248 "../src/application.vala"
		msg = _tmp3_;
#line 250 "../src/application.vala"
		_tmp4_ = stderr;
#line 250 "../src/application.vala"
		_tmp5_ = msg;
#line 250 "../src/application.vala"
		fprintf (_tmp4_, "%s\n", _tmp5_);
#line 251 "../src/application.vala"
		_tmp6_ = msg;
#line 251 "../src/application.vala"
		peek_application_show_recording_backend_warning (self, _tmp6_);
#line 244 "../src/application.vala"
		_g_free0 (msg);
#line 244 "../src/application.vala"
		_g_error_free0 (e);
#line 895 "application.c"
	}
	__finally0:
#line 244 "../src/application.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 244 "../src/application.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 244 "../src/application.vala"
		g_clear_error (&_inner_error0_);
#line 244 "../src/application.vala"
		return;
#line 906 "application.c"
	}
}

static void
peek_application_new_window_with_backend (PeekApplication* self,
                                          GVariant* backend)
{
	gsize length = 0UL;
	gchar* backend_name = NULL;
	gsize _tmp0_ = 0UL;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	FILE* _tmp3_;
	GError* _inner_error0_ = NULL;
#line 255 "../src/application.vala"
	g_return_if_fail (self != NULL);
#line 257 "../src/application.vala"
	_tmp1_ = g_variant_get_string (backend, &_tmp0_);
#line 257 "../src/application.vala"
	length = _tmp0_;
#line 257 "../src/application.vala"
	_tmp2_ = g_strdup (_tmp1_);
#line 257 "../src/application.vala"
	backend_name = _tmp2_;
#line 258 "../src/application.vala"
	_tmp3_ = stdout;
#line 258 "../src/application.vala"
	fprintf (_tmp3_, "Requested screen recording backend %s\n", backend_name);
#line 935 "application.c"
	{
		PeekRecordingScreenRecorder* recorder = NULL;
		PeekRecordingScreenRecorder* _tmp4_;
#line 261 "../src/application.vala"
		_tmp4_ = peek_recording_screen_recorder_factory_create_screen_recorder (backend_name, &_inner_error0_);
#line 261 "../src/application.vala"
		recorder = _tmp4_;
#line 261 "../src/application.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 261 "../src/application.vala"
			if (_inner_error0_->domain == PEEK_PEEK_ERROR) {
#line 947 "application.c"
				goto __catch0_peek_peek_error;
			}
#line 261 "../src/application.vala"
			_g_free0 (backend_name);
#line 261 "../src/application.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 261 "../src/application.vala"
			g_clear_error (&_inner_error0_);
#line 261 "../src/application.vala"
			return;
#line 958 "application.c"
		}
#line 262 "../src/application.vala"
		peek_application_show_window (self, recorder);
#line 260 "../src/application.vala"
		_g_object_unref0 (recorder);
#line 964 "application.c"
	}
	goto __finally0;
	__catch0_peek_peek_error:
	{
		GError* e = NULL;
		gchar* msg = NULL;
		GError* _tmp5_;
		const gchar* _tmp6_;
		gchar* _tmp7_;
		FILE* _tmp8_;
		const gchar* _tmp9_;
		const gchar* _tmp10_;
#line 260 "../src/application.vala"
		e = _inner_error0_;
#line 260 "../src/application.vala"
		_inner_error0_ = NULL;
#line 264 "../src/application.vala"
		_tmp5_ = e;
#line 264 "../src/application.vala"
		_tmp6_ = _tmp5_->message;
#line 264 "../src/application.vala"
		_tmp7_ = g_strdup_printf (_ ("Unable to initialize recording backend %s: %s"), backend_name, _tmp6_);
#line 264 "../src/application.vala"
		msg = _tmp7_;
#line 266 "../src/application.vala"
		_tmp8_ = stderr;
#line 266 "../src/application.vala"
		_tmp9_ = msg;
#line 266 "../src/application.vala"
		fprintf (_tmp8_, "%s\n", _tmp9_);
#line 267 "../src/application.vala"
		_tmp10_ = msg;
#line 267 "../src/application.vala"
		peek_application_show_recording_backend_warning (self, _tmp10_);
#line 260 "../src/application.vala"
		_g_free0 (msg);
#line 260 "../src/application.vala"
		_g_error_free0 (e);
#line 1003 "application.c"
	}
	__finally0:
#line 260 "../src/application.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 260 "../src/application.vala"
		_g_free0 (backend_name);
#line 260 "../src/application.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 260 "../src/application.vala"
		g_clear_error (&_inner_error0_);
#line 260 "../src/application.vala"
		return;
#line 1016 "application.c"
	}
#line 255 "../src/application.vala"
	_g_free0 (backend_name);
#line 1020 "application.c"
}

static void
peek_application_set_window_size (PeekApplication* self)
{
	PeekUiApplicationWindow* _tmp0_;
	GtkDialog* _tmp1_;
	GtkDialog* _tmp2_;
#line 271 "../src/application.vala"
	g_return_if_fail (self != NULL);
#line 272 "../src/application.vala"
	_tmp0_ = self->priv->main_window;
#line 272 "../src/application.vala"
	_tmp1_ = peek_ui_set_window_size_dialog_present_single_instance (_tmp0_);
#line 272 "../src/application.vala"
	_tmp2_ = _tmp1_;
#line 272 "../src/application.vala"
	_g_object_unref0 (_tmp2_);
#line 1039 "application.c"
}

static void
peek_application_show_window (PeekApplication* self,
                              PeekRecordingScreenRecorder* recorder)
{
	PeekUiApplicationWindow* _tmp0_;
	PeekUiApplicationWindow* _tmp1_;
#line 275 "../src/application.vala"
	g_return_if_fail (self != NULL);
#line 275 "../src/application.vala"
	g_return_if_fail (recorder != NULL);
#line 276 "../src/application.vala"
	if (peek_desktop_integration_is_wayland_backend ()) {
#line 277 "../src/application.vala"
		peek_application_show_wayland_warning (self);
#line 278 "../src/application.vala"
		return;
#line 1058 "application.c"
	}
#line 281 "../src/application.vala"
	_tmp0_ = peek_ui_application_window_new (self, recorder);
#line 281 "../src/application.vala"
	g_object_ref_sink (_tmp0_);
#line 281 "../src/application.vala"
	_g_object_unref0 (self->priv->main_window);
#line 281 "../src/application.vala"
	self->priv->main_window = _tmp0_;
#line 282 "../src/application.vala"
	_tmp1_ = self->priv->main_window;
#line 282 "../src/application.vala"
	gtk_window_present ((GtkWindow*) _tmp1_);
#line 1072 "application.c"
}

static void
peek_application_show_preferences (PeekApplication* self)
{
	PeekUiApplicationWindow* _tmp0_;
	GtkWindow* _tmp1_;
	GtkWindow* _tmp2_;
#line 285 "../src/application.vala"
	g_return_if_fail (self != NULL);
#line 286 "../src/application.vala"
	_tmp0_ = self->priv->main_window;
#line 286 "../src/application.vala"
	_tmp1_ = peek_ui_preferences_dialog_present_single_instance ((GtkWindow*) _tmp0_);
#line 286 "../src/application.vala"
	_tmp2_ = _tmp1_;
#line 286 "../src/application.vala"
	_g_object_unref0 (_tmp2_);
#line 1091 "application.c"
}

static void
peek_application_show_about (PeekApplication* self)
{
	PeekUiApplicationWindow* _tmp0_;
	GtkDialog* _tmp1_;
	GtkDialog* _tmp2_;
#line 289 "../src/application.vala"
	g_return_if_fail (self != NULL);
#line 290 "../src/application.vala"
	_tmp0_ = self->priv->main_window;
#line 290 "../src/application.vala"
	_tmp1_ = peek_ui_about_dialog_present_single_instance ((GtkWindow*) _tmp0_);
#line 290 "../src/application.vala"
	_tmp2_ = _tmp1_;
#line 290 "../src/application.vala"
	_g_object_unref0 (_tmp2_);
#line 1110 "application.c"
}

static void
peek_application_load_stylesheets (void)
{
	gchar* theme = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	const gchar* _tmp4_;
#line 294 "../src/application.vala"
	peek_application_load_stylesheet_by_name ("peek");
#line 295 "../src/application.vala"
	_tmp0_ = peek_desktop_integration_get_theme_name ();
#line 295 "../src/application.vala"
	theme = _tmp0_;
#line 296 "../src/application.vala"
	_tmp1_ = theme;
#line 296 "../src/application.vala"
	g_debug ("application.vala:296: GTK theme: %s", _tmp1_);
#line 297 "../src/application.vala"
	_tmp4_ = theme;
#line 297 "../src/application.vala"
	if (g_strcmp0 (_tmp4_, "Ambiance") == 0) {
#line 297 "../src/application.vala"
		_tmp3_ = TRUE;
#line 1138 "application.c"
	} else {
		const gchar* _tmp5_;
#line 297 "../src/application.vala"
		_tmp5_ = theme;
#line 297 "../src/application.vala"
		_tmp3_ = g_strcmp0 (_tmp5_, "Breeze") == 0;
#line 1145 "application.c"
	}
#line 297 "../src/application.vala"
	if (_tmp3_) {
#line 297 "../src/application.vala"
		_tmp2_ = TRUE;
#line 1151 "application.c"
	} else {
		const gchar* _tmp6_;
#line 297 "../src/application.vala"
		_tmp6_ = theme;
#line 297 "../src/application.vala"
		_tmp2_ = g_strcmp0 (_tmp6_, "Breeze-Dark") == 0;
#line 1158 "application.c"
	}
#line 297 "../src/application.vala"
	if (_tmp2_) {
#line 1162 "application.c"
		const gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
#line 298 "../src/application.vala"
		_tmp7_ = theme;
#line 298 "../src/application.vala"
		_tmp8_ = g_utf8_strdown (_tmp7_, (gssize) -1);
#line 298 "../src/application.vala"
		_tmp9_ = _tmp8_;
#line 298 "../src/application.vala"
		peek_application_load_stylesheet_by_name (_tmp9_);
#line 298 "../src/application.vala"
		_g_free0 (_tmp9_);
#line 1176 "application.c"
	}
#line 301 "../src/application.vala"
	if (peek_desktop_integration_is_unity ()) {
#line 302 "../src/application.vala"
		peek_application_load_stylesheet_by_name ("unity");
#line 1182 "application.c"
	}
#line 293 "../src/application.vala"
	_g_free0 (theme);
#line 1186 "application.c"
}

static void
peek_application_load_stylesheet_by_name (const gchar* name)
{
	gchar* uri = NULL;
	gchar* _tmp0_;
#line 306 "../src/application.vala"
	g_return_if_fail (name != NULL);
#line 307 "../src/application.vala"
	_tmp0_ = g_strdup_printf ("resource:///com/uploadedlobster/peek/css/%s.css", name);
#line 307 "../src/application.vala"
	uri = _tmp0_;
#line 308 "../src/application.vala"
	peek_application_load_stylesheet_from_uri (uri);
#line 306 "../src/application.vala"
	_g_free0 (uri);
#line 1204 "application.c"
}

static void
peek_application_load_stylesheet_from_uri (const gchar* uri)
{
	GtkCssProvider* provider = NULL;
	GtkCssProvider* _tmp0_;
	GError* _inner_error0_ = NULL;
#line 311 "../src/application.vala"
	g_return_if_fail (uri != NULL);
#line 312 "../src/application.vala"
	_tmp0_ = gtk_css_provider_new ();
#line 312 "../src/application.vala"
	provider = _tmp0_;
#line 1219 "application.c"
	{
		GFile* file = NULL;
		GFile* _tmp1_;
		GdkScreen* screen = NULL;
		GdkScreen* _tmp2_;
		GdkScreen* _tmp3_;
		GdkScreen* _tmp4_;
#line 314 "../src/application.vala"
		_tmp1_ = g_file_new_for_uri (uri);
#line 314 "../src/application.vala"
		file = _tmp1_;
#line 315 "../src/application.vala"
		gtk_css_provider_load_from_file (provider, file, &_inner_error0_);
#line 315 "../src/application.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 315 "../src/application.vala"
			_g_object_unref0 (file);
#line 1237 "application.c"
			goto __catch0_g_error;
		}
#line 316 "../src/application.vala"
		_tmp2_ = gdk_screen_get_default ();
#line 316 "../src/application.vala"
		_tmp3_ = _g_object_ref0 (_tmp2_);
#line 316 "../src/application.vala"
		screen = _tmp3_;
#line 317 "../src/application.vala"
		_tmp4_ = screen;
#line 317 "../src/application.vala"
		gtk_style_context_add_provider_for_screen (_tmp4_, (GtkStyleProvider*) provider, PEEK_APPLICATION_GTK_STYLE_PROVIDER_PRIORITY_APPLICATION);
#line 313 "../src/application.vala"
		_g_object_unref0 (screen);
#line 313 "../src/application.vala"
		_g_object_unref0 (file);
#line 1254 "application.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		FILE* _tmp5_;
		GError* _tmp6_;
		const gchar* _tmp7_;
#line 313 "../src/application.vala"
		e = _inner_error0_;
#line 313 "../src/application.vala"
		_inner_error0_ = NULL;
#line 321 "../src/application.vala"
		_tmp5_ = stderr;
#line 321 "../src/application.vala"
		_tmp6_ = e;
#line 321 "../src/application.vala"
		_tmp7_ = _tmp6_->message;
#line 321 "../src/application.vala"
		fprintf (_tmp5_, "Loading application stylesheet %s failed: %s", uri, _tmp7_);
#line 313 "../src/application.vala"
		_g_error_free0 (e);
#line 1277 "application.c"
	}
	__finally0:
#line 313 "../src/application.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 313 "../src/application.vala"
		_g_object_unref0 (provider);
#line 313 "../src/application.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 313 "../src/application.vala"
		g_clear_error (&_inner_error0_);
#line 313 "../src/application.vala"
		return;
#line 1290 "application.c"
	}
#line 311 "../src/application.vala"
	_g_object_unref0 (provider);
#line 1294 "application.c"
}

static void
peek_application_show_file (PeekApplication* self,
                            GVariant* uri)
{
	gchar* uri_str = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	GFile* file = NULL;
	GFile* _tmp2_;
#line 326 "../src/application.vala"
	g_return_if_fail (self != NULL);
#line 327 "../src/application.vala"
	_tmp0_ = g_variant_get_string (uri, NULL);
#line 327 "../src/application.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 327 "../src/application.vala"
	uri_str = _tmp1_;
#line 328 "../src/application.vala"
	g_debug ("application.vala:328: Action show-file called with URI %s", uri_str);
#line 329 "../src/application.vala"
	_tmp2_ = g_file_new_for_uri (uri_str);
#line 329 "../src/application.vala"
	file = _tmp2_;
#line 330 "../src/application.vala"
	peek_desktop_integration_launch_file_manager (file);
#line 326 "../src/application.vala"
	_g_object_unref0 (file);
#line 326 "../src/application.vala"
	_g_free0 (uri_str);
#line 1326 "application.c"
}

static void
peek_application_show_recording_backend_warning (PeekApplication* self,
                                                 const gchar* msg)
{
#line 334 "../src/application.vala"
	g_return_if_fail (self != NULL);
#line 334 "../src/application.vala"
	g_return_if_fail (msg != NULL);
#line 335 "../src/application.vala"
	peek_application_show_startup_warning (self, _ ("Recording backend unavailable"), msg);
#line 1339 "application.c"
}

static void
peek_application_show_wayland_warning (PeekApplication* self)
{
	gchar* title = NULL;
	gchar* _tmp0_;
	gchar* text = NULL;
	gchar* _tmp1_;
#line 338 "../src/application.vala"
	g_return_if_fail (self != NULL);
#line 339 "../src/application.vala"
	_tmp0_ = g_strdup (_ ("Native Wayland backend is unsupported"));
#line 339 "../src/application.vala"
	title = _tmp0_;
#line 340 "../src/application.vala"
	_tmp1_ = g_strdup (_ ("You are running Peek natively on Wayland, this is currently unsupporte" \
"d. Please start Peek using XWayland by setting <tt>GDK_BACKEND=x11</tt" \
">.\n" \
"\n" \
"For Details see the Peek <a href='https://github.com/phw/peek#why-no-n" \
"ative-wayland-support'>FAQ about Wayland support</a>."));
#line 340 "../src/application.vala"
	text = _tmp1_;
#line 341 "../src/application.vala"
	peek_application_show_startup_warning (self, title, text);
#line 338 "../src/application.vala"
	_g_free0 (text);
#line 338 "../src/application.vala"
	_g_free0 (title);
#line 1365 "application.c"
}

static void
peek_application_show_startup_warning (PeekApplication* self,
                                       const gchar* title,
                                       const gchar* text)
{
	GtkMessageDialog* msg = NULL;
	GtkMessageDialog* _tmp0_;
#line 344 "../src/application.vala"
	g_return_if_fail (self != NULL);
#line 344 "../src/application.vala"
	g_return_if_fail (title != NULL);
#line 344 "../src/application.vala"
	g_return_if_fail (text != NULL);
#line 348 "../src/application.vala"
	_tmp0_ = (GtkMessageDialog*) gtk_message_dialog_new (NULL, GTK_DIALOG_MODAL, GTK_MESSAGE_WARNING, GTK_BUTTONS_OK, "%s", "");
#line 348 "../src/application.vala"
	g_object_ref_sink (_tmp0_);
#line 348 "../src/application.vala"
	msg = _tmp0_;
#line 350 "../src/application.vala"
	g_object_set (msg, "text", title, NULL);
#line 351 "../src/application.vala"
	g_object_set (msg, "secondary-use-markup", TRUE, NULL);
#line 352 "../src/application.vala"
	g_object_set (msg, "secondary-text", text, NULL);
#line 353 "../src/application.vala"
	gtk_dialog_run ((GtkDialog*) msg);
#line 344 "../src/application.vala"
	_g_object_unref0 (msg);
#line 1397 "application.c"
}

gboolean
peek_application_get_keybindings_paused (void)
{
	gboolean result;
#line 54 "../src/application.vala"
	result = peek_application__keybindings_paused;
#line 54 "../src/application.vala"
	return result;
#line 1408 "application.c"
}

void
peek_application_set_keybindings_paused (gboolean value)
{
#line 54 "../src/application.vala"
	peek_application__keybindings_paused = value;
#line 1416 "application.c"
}

const gchar*
peek_application_get_keybinding_toggle_recording (PeekApplication* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 219 "../src/application.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 219 "../src/application.vala"
	_tmp0_ = self->priv->_keybinding_toggle_recording;
#line 219 "../src/application.vala"
	result = _tmp0_;
#line 219 "../src/application.vala"
	return result;
#line 1432 "application.c"
}

static void
_peek_application_handle_keybinding_toggle_recording_keybinder_handler (const gchar* keystring,
                                                                        gpointer self)
{
#line 228 "../src/application.vala"
	peek_application_handle_keybinding_toggle_recording ((PeekApplication*) self, keystring);
#line 1441 "application.c"
}

void
peek_application_set_keybinding_toggle_recording (PeekApplication* self,
                                                  const gchar* value)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp3_;
#line 220 "../src/application.vala"
	g_return_if_fail (self != NULL);
#line 221 "../src/application.vala"
	_tmp0_ = self->priv->_keybinding_toggle_recording;
#line 221 "../src/application.vala"
	g_debug ("application.vala:221: Changed keybinding_toggle_recording %s => %s\n", _tmp0_, value);
#line 223 "../src/application.vala"
	_tmp1_ = self->priv->_keybinding_toggle_recording;
#line 223 "../src/application.vala"
	if (g_strcmp0 (_tmp1_, "") != 0) {
#line 1461 "application.c"
		const gchar* _tmp2_;
#line 224 "../src/application.vala"
		_tmp2_ = self->priv->_keybinding_toggle_recording;
#line 224 "../src/application.vala"
		keybinder_unbind_all (_tmp2_);
#line 1467 "application.c"
	}
#line 227 "../src/application.vala"
	if (g_strcmp0 (value, "") != 0) {
#line 228 "../src/application.vala"
		keybinder_bind_full (value, _peek_application_handle_keybinding_toggle_recording_keybinder_handler, g_object_ref (self), g_object_unref);
#line 1473 "application.c"
	}
#line 231 "../src/application.vala"
	_tmp3_ = g_strdup (value);
#line 231 "../src/application.vala"
	_g_free0 (self->priv->_keybinding_toggle_recording);
#line 231 "../src/application.vala"
	self->priv->_keybinding_toggle_recording = _tmp3_;
#line 220 "../src/application.vala"
	g_object_notify_by_pspec ((GObject *) self, peek_application_properties[PEEK_APPLICATION_KEYBINDING_TOGGLE_RECORDING_PROPERTY]);
#line 1483 "application.c"
}

static void
peek_application_class_init (PeekApplicationClass * klass,
                             gpointer klass_data)
{
#line 15 "../src/application.vala"
	peek_application_parent_class = g_type_class_peek_parent (klass);
#line 15 "../src/application.vala"
	g_type_class_adjust_private_offset (klass, &PeekApplication_private_offset);
#line 15 "../src/application.vala"
	((GApplicationClass *) klass)->activate = (void (*) (GApplication*)) peek_application_real_activate;
#line 15 "../src/application.vala"
	((GApplicationClass *) klass)->startup = (void (*) (GApplication*)) peek_application_real_startup;
#line 15 "../src/application.vala"
	((GApplicationClass *) klass)->shutdown = (void (*) (GApplication*)) peek_application_real_shutdown;
#line 15 "../src/application.vala"
	((GApplicationClass *) klass)->handle_local_options = (gint (*) (GApplication*, GVariantDict*)) peek_application_real_handle_local_options;
#line 15 "../src/application.vala"
	((GApplicationClass *) klass)->command_line = (gint (*) (GApplication*, GApplicationCommandLine*)) peek_application_real_command_line;
#line 15 "../src/application.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_peek_application_get_property;
#line 15 "../src/application.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_peek_application_set_property;
#line 15 "../src/application.vala"
	G_OBJECT_CLASS (klass)->finalize = peek_application_finalize;
#line 15 "../src/application.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PEEK_APPLICATION_KEYBINDING_TOGGLE_RECORDING_PROPERTY, peek_application_properties[PEEK_APPLICATION_KEYBINDING_TOGGLE_RECORDING_PROPERTY] = g_param_spec_string ("keybinding-toggle-recording", "keybinding-toggle-recording", "keybinding-toggle-recording", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 15 "../src/application.vala"
	peek_application_signals[PEEK_APPLICATION_TOGGLE_RECORDING_SIGNAL] = g_signal_new ("toggle-recording", PEEK_TYPE_APPLICATION, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 15 "../src/application.vala"
	peek_application_signals[PEEK_APPLICATION_START_RECORDING_SIGNAL] = g_signal_new ("start-recording", PEEK_TYPE_APPLICATION, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 15 "../src/application.vala"
	peek_application_signals[PEEK_APPLICATION_STOP_RECORDING_SIGNAL] = g_signal_new ("stop-recording", PEEK_TYPE_APPLICATION, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 1518 "application.c"
}

static void
peek_application_instance_init (PeekApplication * self,
                                gpointer klass)
{
	gchar* _tmp0_;
#line 15 "../src/application.vala"
	self->priv = peek_application_get_instance_private (self);
#line 217 "../src/application.vala"
	_tmp0_ = g_strdup ("");
#line 217 "../src/application.vala"
	self->priv->_keybinding_toggle_recording = _tmp0_;
#line 1532 "application.c"
}

static void
peek_application_finalize (GObject * obj)
{
	PeekApplication * self;
#line 15 "../src/application.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PEEK_TYPE_APPLICATION, PeekApplication);
#line 19 "../src/application.vala"
	_g_object_unref0 (self->priv->main_window);
#line 217 "../src/application.vala"
	_g_free0 (self->priv->_keybinding_toggle_recording);
#line 15 "../src/application.vala"
	G_OBJECT_CLASS (peek_application_parent_class)->finalize (obj);
#line 1547 "application.c"
}

static GType
peek_application_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PeekApplicationClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) peek_application_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PeekApplication), 0, (GInstanceInitFunc) peek_application_instance_init, NULL };
	GType peek_application_type_id;
	peek_application_type_id = g_type_register_static (gtk_application_get_type (), "PeekApplication", &g_define_type_info, 0);
	PeekApplication_private_offset = g_type_add_instance_private (peek_application_type_id, sizeof (PeekApplicationPrivate));
	return peek_application_type_id;
}

GType
peek_application_get_type (void)
{
	static volatile gsize peek_application_type_id__once = 0;
	if (g_once_init_enter (&peek_application_type_id__once)) {
		GType peek_application_type_id;
		peek_application_type_id = peek_application_get_type_once ();
		g_once_init_leave (&peek_application_type_id__once, peek_application_type_id);
	}
	return peek_application_type_id__once;
}

static void
_vala_peek_application_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec)
{
	PeekApplication * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, PEEK_TYPE_APPLICATION, PeekApplication);
#line 15 "../src/application.vala"
	switch (property_id) {
#line 15 "../src/application.vala"
		case PEEK_APPLICATION_KEYBINDING_TOGGLE_RECORDING_PROPERTY:
#line 15 "../src/application.vala"
		g_value_set_string (value, peek_application_get_keybinding_toggle_recording (self));
#line 15 "../src/application.vala"
		break;
#line 1588 "application.c"
		default:
#line 15 "../src/application.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 15 "../src/application.vala"
		break;
#line 1594 "application.c"
	}
}

static void
_vala_peek_application_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec)
{
	PeekApplication * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, PEEK_TYPE_APPLICATION, PeekApplication);
#line 15 "../src/application.vala"
	switch (property_id) {
#line 15 "../src/application.vala"
		case PEEK_APPLICATION_KEYBINDING_TOGGLE_RECORDING_PROPERTY:
#line 15 "../src/application.vala"
		peek_application_set_keybinding_toggle_recording (self, g_value_get_string (value));
#line 15 "../src/application.vala"
		break;
#line 1614 "application.c"
		default:
#line 15 "../src/application.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 15 "../src/application.vala"
		break;
#line 1620 "application.c"
	}
}

