/* desktop-integration.c generated by valac 0.56.17, the Vala compiler
 * generated from desktop-integration.vala, do not modify */

/*
Peek Copyright (c) 2015-2017 by Philipp Wolfer <ph.wolfer@gmail.com>

This file is part of Peek.

This software is licensed under the GNU General Public License
(version 3 or later). See the LICENSE file in this distribution.
*/

#include "../../application.h"
#include <glib.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <glib-object.h>
#include <gdk/gdk.h>
#include <glib/gstdio.h>
#include <gobject/gvaluecollector.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_match_info_unref0(var) ((var == NULL) ? NULL : (var = (g_match_info_unref (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
typedef struct _PeekParamSpecDesktopIntegration PeekParamSpecDesktopIntegration;

struct _PeekParamSpecDesktopIntegration {
	GParamSpec parent_instance;
};

static gpointer peek_desktop_integration_parent_class = NULL;
static FreedesktopFileManager1* peek_desktop_integration__file_manager_service;
static FreedesktopFileManager1* peek_desktop_integration__file_manager_service = NULL;
static gboolean peek_desktop_integration__file_manager_dbus_initialized;
static gboolean peek_desktop_integration__file_manager_dbus_initialized = FALSE;

static FreedesktopFileManager1* peek_desktop_integration_get_file_manager_service (void);
static gboolean peek_desktop_integration_file_manager_highlights_file (GAppInfo* app_info);
static void _g_free0_ (gpointer var);
static inline void _g_list_free__g_free0_ (GList* self);
static gboolean peek_desktop_integration_xdg_current_desktop_contains (const gchar* text);
static gchar* peek_desktop_integration_get_theme_name_from_settings_file (void);
static void peek_desktop_integration_finalize (PeekDesktopIntegration * obj);
static GType peek_desktop_integration_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static void
_g_free0_ (gpointer var)
{
#line 90 "../src/desktop-integration.vala"
	var = (g_free (var), NULL);
#line 71 "desktop-integration.c"
}

static inline void
_g_list_free__g_free0_ (GList* self)
{
#line 90 "../src/desktop-integration.vala"
	g_list_free_full (self, (GDestroyNotify) _g_free0_);
#line 79 "desktop-integration.c"
}

gboolean
peek_desktop_integration_launch_file_manager (GFile* file)
{
	gchar* uri = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	FreedesktopFileManager1* _tmp2_;
	FreedesktopFileManager1* _tmp3_;
	GFile* parent = NULL;
	GFile* _tmp15_;
	gboolean _tmp63_ = FALSE;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 37 "../src/desktop-integration.vala"
	g_return_val_if_fail (file != NULL, FALSE);
#line 38 "../src/desktop-integration.vala"
	_tmp0_ = g_file_get_uri (file);
#line 38 "../src/desktop-integration.vala"
	uri = _tmp0_;
#line 39 "../src/desktop-integration.vala"
	_tmp1_ = uri;
#line 39 "../src/desktop-integration.vala"
	g_debug ("desktop-integration.vala:39: File URI: %s\n", _tmp1_);
#line 42 "../src/desktop-integration.vala"
	_tmp2_ = peek_desktop_integration_get_file_manager_service ();
#line 42 "../src/desktop-integration.vala"
	_tmp3_ = _tmp2_;
#line 42 "../src/desktop-integration.vala"
	if (_tmp3_ != NULL) {
#line 111 "desktop-integration.c"
		{
			const gchar* _tmp4_;
			FreedesktopFileManager1* _tmp5_;
			FreedesktopFileManager1* _tmp6_;
			const gchar* _tmp7_;
			gchar* _tmp8_;
			gchar** _tmp9_;
			gchar** _tmp10_;
			gint _tmp10__length1;
#line 44 "../src/desktop-integration.vala"
			_tmp4_ = uri;
#line 44 "../src/desktop-integration.vala"
			g_debug ("desktop-integration.vala:44: Launching org.freedesktop.FileManager1 fo" \
"r URI: %s\n", _tmp4_);
#line 45 "../src/desktop-integration.vala"
			_tmp5_ = peek_desktop_integration_get_file_manager_service ();
#line 45 "../src/desktop-integration.vala"
			_tmp6_ = _tmp5_;
#line 45 "../src/desktop-integration.vala"
			_tmp7_ = uri;
#line 45 "../src/desktop-integration.vala"
			_tmp8_ = g_strdup (_tmp7_);
#line 45 "../src/desktop-integration.vala"
			_tmp9_ = g_new0 (gchar*, 1 + 1);
#line 45 "../src/desktop-integration.vala"
			_tmp9_[0] = _tmp8_;
#line 45 "../src/desktop-integration.vala"
			_tmp10_ = _tmp9_;
#line 45 "../src/desktop-integration.vala"
			_tmp10__length1 = 1;
#line 45 "../src/desktop-integration.vala"
			freedesktop_file_manager1_show_items (_tmp6_, _tmp10_, (gint) 1, "", &_inner_error0_);
#line 45 "../src/desktop-integration.vala"
			_tmp10_ = (_vala_array_free (_tmp10_, _tmp10__length1, (GDestroyNotify) g_free), NULL);
#line 45 "../src/desktop-integration.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 147 "desktop-integration.c"
				goto __catch0_g_error;
			}
#line 46 "../src/desktop-integration.vala"
			result = TRUE;
#line 46 "../src/desktop-integration.vala"
			_g_free0 (uri);
#line 46 "../src/desktop-integration.vala"
			return result;
#line 156 "desktop-integration.c"
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			FILE* _tmp11_;
			GError* _tmp12_;
			const gchar* _tmp13_;
#line 43 "../src/desktop-integration.vala"
			e = _inner_error0_;
#line 43 "../src/desktop-integration.vala"
			_inner_error0_ = NULL;
#line 48 "../src/desktop-integration.vala"
			_tmp11_ = stderr;
#line 48 "../src/desktop-integration.vala"
			_tmp12_ = e;
#line 48 "../src/desktop-integration.vala"
			_tmp13_ = _tmp12_->message;
#line 48 "../src/desktop-integration.vala"
			fprintf (_tmp11_, "Unable to call org.freedesktop.FileManager1: %s\n", _tmp13_);
#line 43 "../src/desktop-integration.vala"
			_g_error_free0 (e);
#line 179 "desktop-integration.c"
		}
		__finally0:
#line 43 "../src/desktop-integration.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 184 "desktop-integration.c"
			gboolean _tmp14_ = FALSE;
#line 43 "../src/desktop-integration.vala"
			_g_free0 (uri);
#line 43 "../src/desktop-integration.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 43 "../src/desktop-integration.vala"
			g_clear_error (&_inner_error0_);
#line 43 "../src/desktop-integration.vala"
			return _tmp14_;
#line 194 "desktop-integration.c"
		}
	}
#line 55 "../src/desktop-integration.vala"
	_tmp15_ = g_file_get_parent (file);
#line 55 "../src/desktop-integration.vala"
	parent = _tmp15_;
#line 201 "desktop-integration.c"
	{
		GAppInfo* app_info = NULL;
		gboolean _tmp17_ = FALSE;
		GAppInfo* _tmp18_;
		GAppInfo* _tmp28_;
		GFile* _tmp51_;
		const gchar* _tmp54_;
		gchar** args = NULL;
		gchar* _tmp55_;
		const gchar* _tmp56_;
		gchar* _tmp57_;
		gchar** _tmp58_;
		gint args_length1;
		gint _args_size_;
		gchar** _tmp59_;
		gint _tmp59__length1;
#line 57 "../src/desktop-integration.vala"
		app_info = NULL;
#line 58 "../src/desktop-integration.vala"
		if (g_file_has_uri_scheme (file, "file")) {
#line 222 "desktop-integration.c"
			GAppInfo* _tmp16_;
#line 59 "../src/desktop-integration.vala"
			_tmp16_ = g_app_info_get_default_for_type ("inode/directory", TRUE);
#line 59 "../src/desktop-integration.vala"
			_g_object_unref0 (app_info);
#line 59 "../src/desktop-integration.vala"
			app_info = _tmp16_;
#line 230 "desktop-integration.c"
		}
#line 63 "../src/desktop-integration.vala"
		_tmp18_ = app_info;
#line 63 "../src/desktop-integration.vala"
		if (_tmp18_ == NULL) {
#line 236 "desktop-integration.c"
			GFile* _tmp19_;
#line 63 "../src/desktop-integration.vala"
			_tmp19_ = parent;
#line 63 "../src/desktop-integration.vala"
			_tmp17_ = _tmp19_ != NULL;
#line 242 "desktop-integration.c"
		} else {
#line 63 "../src/desktop-integration.vala"
			_tmp17_ = FALSE;
#line 246 "desktop-integration.c"
		}
#line 63 "../src/desktop-integration.vala"
		if (_tmp17_) {
#line 250 "desktop-integration.c"
			{
				GAppInfo* _tmp20_ = NULL;
				GFile* _tmp21_;
				GAppInfo* _tmp22_;
				GAppInfo* _tmp23_;
#line 65 "../src/desktop-integration.vala"
				_tmp21_ = parent;
#line 65 "../src/desktop-integration.vala"
				_tmp22_ = g_file_query_default_handler (_tmp21_, NULL, &_inner_error0_);
#line 65 "../src/desktop-integration.vala"
				_tmp20_ = _tmp22_;
#line 65 "../src/desktop-integration.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 264 "desktop-integration.c"
					goto __catch2_g_error;
				}
#line 65 "../src/desktop-integration.vala"
				_tmp23_ = _tmp20_;
#line 65 "../src/desktop-integration.vala"
				_tmp20_ = NULL;
#line 65 "../src/desktop-integration.vala"
				_g_object_unref0 (app_info);
#line 65 "../src/desktop-integration.vala"
				app_info = _tmp23_;
#line 64 "../src/desktop-integration.vala"
				_g_object_unref0 (_tmp20_);
#line 277 "desktop-integration.c"
			}
			goto __finally2;
			__catch2_g_error:
			{
				FILE* _tmp24_;
				GFile* _tmp25_;
				gchar* _tmp26_;
				gchar* _tmp27_;
#line 64 "../src/desktop-integration.vala"
				g_clear_error (&_inner_error0_);
#line 67 "../src/desktop-integration.vala"
				_tmp24_ = stderr;
#line 67 "../src/desktop-integration.vala"
				_tmp25_ = parent;
#line 67 "../src/desktop-integration.vala"
				_tmp26_ = g_file_get_uri (_tmp25_);
#line 67 "../src/desktop-integration.vala"
				_tmp27_ = _tmp26_;
#line 67 "../src/desktop-integration.vala"
				fprintf (_tmp24_, "Unable to get AppInfo for parent folder: %s\n", _tmp27_);
#line 67 "../src/desktop-integration.vala"
				_g_free0 (_tmp27_);
#line 300 "desktop-integration.c"
			}
			__finally2:
#line 64 "../src/desktop-integration.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 64 "../src/desktop-integration.vala"
				_g_object_unref0 (app_info);
#line 307 "desktop-integration.c"
				goto __catch1_g_error;
			}
		}
#line 71 "../src/desktop-integration.vala"
		_tmp28_ = app_info;
#line 71 "../src/desktop-integration.vala"
		if (_tmp28_ != NULL) {
#line 315 "desktop-integration.c"
			GAppInfo* _tmp29_;
			const gchar* _tmp30_;
			const gchar* _tmp31_;
			GAppInfo* _tmp32_;
			const gchar* _tmp33_;
#line 72 "../src/desktop-integration.vala"
			_tmp29_ = app_info;
#line 72 "../src/desktop-integration.vala"
			_tmp30_ = g_app_info_get_executable (_tmp29_);
#line 72 "../src/desktop-integration.vala"
			_tmp31_ = uri;
#line 72 "../src/desktop-integration.vala"
			g_debug ("desktop-integration.vala:72: Launching \"%s\" for URI: %s\n", _tmp30_, _tmp31_);
#line 74 "../src/desktop-integration.vala"
			_tmp32_ = app_info;
#line 74 "../src/desktop-integration.vala"
			_tmp33_ = g_app_info_get_executable (_tmp32_);
#line 74 "../src/desktop-integration.vala"
			if (g_strcmp0 (_tmp33_, "dolphin") == 0) {
#line 335 "desktop-integration.c"
				gchar** args = NULL;
				GAppInfo* _tmp34_;
				const gchar* _tmp35_;
				gchar* _tmp36_;
				gchar* _tmp37_;
				const gchar* _tmp38_;
				gchar* _tmp39_;
				gchar** _tmp40_;
				gint args_length1;
				gint _args_size_;
				gchar** _tmp41_;
				gint _tmp41__length1;
#line 76 "../src/desktop-integration.vala"
				_tmp34_ = app_info;
#line 76 "../src/desktop-integration.vala"
				_tmp35_ = g_app_info_get_executable (_tmp34_);
#line 76 "../src/desktop-integration.vala"
				_tmp36_ = g_strdup (_tmp35_);
#line 76 "../src/desktop-integration.vala"
				_tmp37_ = g_strdup ("--select");
#line 76 "../src/desktop-integration.vala"
				_tmp38_ = uri;
#line 76 "../src/desktop-integration.vala"
				_tmp39_ = g_strdup (_tmp38_);
#line 76 "../src/desktop-integration.vala"
				_tmp40_ = g_new0 (gchar*, 3 + 1);
#line 76 "../src/desktop-integration.vala"
				_tmp40_[0] = _tmp36_;
#line 76 "../src/desktop-integration.vala"
				_tmp40_[1] = _tmp37_;
#line 76 "../src/desktop-integration.vala"
				_tmp40_[2] = _tmp39_;
#line 76 "../src/desktop-integration.vala"
				args = _tmp40_;
#line 76 "../src/desktop-integration.vala"
				args_length1 = 3;
#line 76 "../src/desktop-integration.vala"
				_args_size_ = args_length1;
#line 79 "../src/desktop-integration.vala"
				_tmp41_ = args;
#line 79 "../src/desktop-integration.vala"
				_tmp41__length1 = args_length1;
#line 79 "../src/desktop-integration.vala"
				g_spawn_sync (NULL, _tmp41_, NULL, G_SPAWN_SEARCH_PATH, NULL, NULL, NULL, NULL, NULL, &_inner_error0_);
#line 79 "../src/desktop-integration.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 79 "../src/desktop-integration.vala"
					args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
#line 79 "../src/desktop-integration.vala"
					_g_object_unref0 (app_info);
#line 386 "desktop-integration.c"
					goto __catch1_g_error;
				}
#line 74 "../src/desktop-integration.vala"
				args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
#line 391 "desktop-integration.c"
			} else {
				gboolean _tmp42_ = FALSE;
				GFile* _tmp43_;
				GList* uri_list = NULL;
				const gchar* _tmp47_;
				gchar* _tmp48_;
				GAppInfo* _tmp49_;
				GList* _tmp50_;
#line 84 "../src/desktop-integration.vala"
				_tmp43_ = parent;
#line 84 "../src/desktop-integration.vala"
				if (_tmp43_ != NULL) {
#line 404 "desktop-integration.c"
					GAppInfo* _tmp44_;
#line 84 "../src/desktop-integration.vala"
					_tmp44_ = app_info;
#line 84 "../src/desktop-integration.vala"
					_tmp42_ = !peek_desktop_integration_file_manager_highlights_file (_tmp44_);
#line 410 "desktop-integration.c"
				} else {
#line 84 "../src/desktop-integration.vala"
					_tmp42_ = FALSE;
#line 414 "desktop-integration.c"
				}
#line 84 "../src/desktop-integration.vala"
				if (_tmp42_) {
#line 418 "desktop-integration.c"
					GFile* _tmp45_;
					gchar* _tmp46_;
#line 85 "../src/desktop-integration.vala"
					_tmp45_ = parent;
#line 85 "../src/desktop-integration.vala"
					_tmp46_ = g_file_get_uri (_tmp45_);
#line 85 "../src/desktop-integration.vala"
					_g_free0 (uri);
#line 85 "../src/desktop-integration.vala"
					uri = _tmp46_;
#line 429 "desktop-integration.c"
				}
#line 88 "../src/desktop-integration.vala"
				uri_list = NULL;
#line 89 "../src/desktop-integration.vala"
				_tmp47_ = uri;
#line 89 "../src/desktop-integration.vala"
				_tmp48_ = g_strdup (_tmp47_);
#line 89 "../src/desktop-integration.vala"
				uri_list = g_list_append (uri_list, _tmp48_);
#line 90 "../src/desktop-integration.vala"
				_tmp49_ = app_info;
#line 90 "../src/desktop-integration.vala"
				_tmp50_ = uri_list;
#line 90 "../src/desktop-integration.vala"
				g_app_info_launch_uris (_tmp49_, _tmp50_, NULL, &_inner_error0_);
#line 90 "../src/desktop-integration.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 90 "../src/desktop-integration.vala"
					(uri_list == NULL) ? NULL : (uri_list = (_g_list_free__g_free0_ (uri_list), NULL));
#line 90 "../src/desktop-integration.vala"
					_g_object_unref0 (app_info);
#line 451 "desktop-integration.c"
					goto __catch1_g_error;
				}
#line 74 "../src/desktop-integration.vala"
				(uri_list == NULL) ? NULL : (uri_list = (_g_list_free__g_free0_ (uri_list), NULL));
#line 456 "desktop-integration.c"
			}
#line 92 "../src/desktop-integration.vala"
			result = TRUE;
#line 92 "../src/desktop-integration.vala"
			_g_object_unref0 (app_info);
#line 92 "../src/desktop-integration.vala"
			_g_object_unref0 (parent);
#line 92 "../src/desktop-integration.vala"
			_g_free0 (uri);
#line 92 "../src/desktop-integration.vala"
			return result;
#line 468 "desktop-integration.c"
		}
#line 95 "../src/desktop-integration.vala"
		_tmp51_ = parent;
#line 95 "../src/desktop-integration.vala"
		if (_tmp51_ != NULL) {
#line 474 "desktop-integration.c"
			GFile* _tmp52_;
			gchar* _tmp53_;
#line 96 "../src/desktop-integration.vala"
			_tmp52_ = parent;
#line 96 "../src/desktop-integration.vala"
			_tmp53_ = g_file_get_uri (_tmp52_);
#line 96 "../src/desktop-integration.vala"
			_g_free0 (uri);
#line 96 "../src/desktop-integration.vala"
			uri = _tmp53_;
#line 485 "desktop-integration.c"
		}
#line 100 "../src/desktop-integration.vala"
		_tmp54_ = uri;
#line 100 "../src/desktop-integration.vala"
		g_debug ("desktop-integration.vala:100: Launching xdg-open for URI: %s\n", _tmp54_);
#line 101 "../src/desktop-integration.vala"
		_tmp55_ = g_strdup ("xdg-open");
#line 101 "../src/desktop-integration.vala"
		_tmp56_ = uri;
#line 101 "../src/desktop-integration.vala"
		_tmp57_ = g_strdup (_tmp56_);
#line 101 "../src/desktop-integration.vala"
		_tmp58_ = g_new0 (gchar*, 2 + 1);
#line 101 "../src/desktop-integration.vala"
		_tmp58_[0] = _tmp55_;
#line 101 "../src/desktop-integration.vala"
		_tmp58_[1] = _tmp57_;
#line 101 "../src/desktop-integration.vala"
		args = _tmp58_;
#line 101 "../src/desktop-integration.vala"
		args_length1 = 2;
#line 101 "../src/desktop-integration.vala"
		_args_size_ = args_length1;
#line 104 "../src/desktop-integration.vala"
		_tmp59_ = args;
#line 104 "../src/desktop-integration.vala"
		_tmp59__length1 = args_length1;
#line 104 "../src/desktop-integration.vala"
		g_spawn_sync (NULL, _tmp59_, NULL, G_SPAWN_SEARCH_PATH, NULL, NULL, NULL, NULL, NULL, &_inner_error0_);
#line 104 "../src/desktop-integration.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 104 "../src/desktop-integration.vala"
			args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
#line 104 "../src/desktop-integration.vala"
			_g_object_unref0 (app_info);
#line 521 "desktop-integration.c"
			goto __catch1_g_error;
		}
#line 107 "../src/desktop-integration.vala"
		result = TRUE;
#line 107 "../src/desktop-integration.vala"
		args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
#line 107 "../src/desktop-integration.vala"
		_g_object_unref0 (app_info);
#line 107 "../src/desktop-integration.vala"
		_g_object_unref0 (parent);
#line 107 "../src/desktop-integration.vala"
		_g_free0 (uri);
#line 107 "../src/desktop-integration.vala"
		return result;
#line 536 "desktop-integration.c"
	}
	goto __finally1;
	__catch1_g_error:
	{
		GError* e = NULL;
		FILE* _tmp60_;
		GError* _tmp61_;
		const gchar* _tmp62_;
#line 56 "../src/desktop-integration.vala"
		e = _inner_error0_;
#line 56 "../src/desktop-integration.vala"
		_inner_error0_ = NULL;
#line 110 "../src/desktop-integration.vala"
		_tmp60_ = stderr;
#line 110 "../src/desktop-integration.vala"
		_tmp61_ = e;
#line 110 "../src/desktop-integration.vala"
		_tmp62_ = _tmp61_->message;
#line 110 "../src/desktop-integration.vala"
		fprintf (_tmp60_, "Launching file manager failed: %s\n", _tmp62_);
#line 111 "../src/desktop-integration.vala"
		result = FALSE;
#line 111 "../src/desktop-integration.vala"
		_g_error_free0 (e);
#line 111 "../src/desktop-integration.vala"
		_g_object_unref0 (parent);
#line 111 "../src/desktop-integration.vala"
		_g_free0 (uri);
#line 111 "../src/desktop-integration.vala"
		return result;
#line 567 "desktop-integration.c"
	}
	__finally1:
#line 56 "../src/desktop-integration.vala"
	_g_object_unref0 (parent);
#line 56 "../src/desktop-integration.vala"
	_g_free0 (uri);
#line 56 "../src/desktop-integration.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 56 "../src/desktop-integration.vala"
	g_clear_error (&_inner_error0_);
#line 56 "../src/desktop-integration.vala"
	return _tmp63_;
#line 580 "desktop-integration.c"
}

gchar*
peek_desktop_integration_get_video_folder (void)
{
	gchar* folder = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp5_;
	gchar* result;
#line 118 "../src/desktop-integration.vala"
	_tmp0_ = g_get_user_special_dir (G_USER_DIRECTORY_VIDEOS);
#line 118 "../src/desktop-integration.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 118 "../src/desktop-integration.vala"
	_g_free0 (folder);
#line 118 "../src/desktop-integration.vala"
	folder = _tmp1_;
#line 120 "../src/desktop-integration.vala"
	_tmp2_ = folder;
#line 120 "../src/desktop-integration.vala"
	if (_tmp2_ == NULL) {
#line 604 "desktop-integration.c"
		const gchar* _tmp3_;
		gchar* _tmp4_;
#line 121 "../src/desktop-integration.vala"
		_tmp3_ = g_get_user_special_dir (G_USER_DIRECTORY_PICTURES);
#line 121 "../src/desktop-integration.vala"
		_tmp4_ = g_strdup (_tmp3_);
#line 121 "../src/desktop-integration.vala"
		_g_free0 (folder);
#line 121 "../src/desktop-integration.vala"
		folder = _tmp4_;
#line 615 "desktop-integration.c"
	}
#line 124 "../src/desktop-integration.vala"
	_tmp5_ = folder;
#line 124 "../src/desktop-integration.vala"
	if (_tmp5_ == NULL) {
#line 621 "desktop-integration.c"
		const gchar* _tmp6_;
		gchar* _tmp7_;
#line 125 "../src/desktop-integration.vala"
		_tmp6_ = g_get_home_dir ();
#line 125 "../src/desktop-integration.vala"
		_tmp7_ = g_strdup (_tmp6_);
#line 125 "../src/desktop-integration.vala"
		_g_free0 (folder);
#line 125 "../src/desktop-integration.vala"
		folder = _tmp7_;
#line 632 "desktop-integration.c"
	}
#line 128 "../src/desktop-integration.vala"
	result = folder;
#line 128 "../src/desktop-integration.vala"
	return result;
#line 638 "desktop-integration.c"
}

gboolean
peek_desktop_integration_is_unity (void)
{
	gboolean result;
#line 132 "../src/desktop-integration.vala"
	result = peek_desktop_integration_xdg_current_desktop_contains ("Unity");
#line 132 "../src/desktop-integration.vala"
	return result;
#line 649 "desktop-integration.c"
}

gboolean
peek_desktop_integration_is_gnome (void)
{
	gboolean result;
#line 136 "../src/desktop-integration.vala"
	result = peek_desktop_integration_xdg_current_desktop_contains ("GNOME");
#line 136 "../src/desktop-integration.vala"
	return result;
#line 660 "desktop-integration.c"
}

gboolean
peek_desktop_integration_is_gnome_shell (void)
{
	gboolean _tmp0_ = FALSE;
	gboolean result;
#line 140 "../src/desktop-integration.vala"
	if (peek_desktop_integration_is_gnome ()) {
#line 140 "../src/desktop-integration.vala"
		_tmp0_ = !peek_desktop_integration_xdg_current_desktop_contains ("Flashback");
#line 672 "desktop-integration.c"
	} else {
#line 140 "../src/desktop-integration.vala"
		_tmp0_ = FALSE;
#line 676 "desktop-integration.c"
	}
#line 140 "../src/desktop-integration.vala"
	result = _tmp0_;
#line 140 "../src/desktop-integration.vala"
	return result;
#line 682 "desktop-integration.c"
}

gboolean
peek_desktop_integration_is_cinnamon (void)
{
	gboolean result;
#line 144 "../src/desktop-integration.vala"
	result = peek_desktop_integration_xdg_current_desktop_contains ("X-Cinnamon");
#line 144 "../src/desktop-integration.vala"
	return result;
#line 693 "desktop-integration.c"
}

gboolean
peek_desktop_integration_is_xfce (void)
{
	gboolean result;
#line 148 "../src/desktop-integration.vala"
	result = peek_desktop_integration_xdg_current_desktop_contains ("XFCE");
#line 148 "../src/desktop-integration.vala"
	return result;
#line 704 "desktop-integration.c"
}

gboolean
peek_desktop_integration_is_plasma (void)
{
	gboolean result;
#line 152 "../src/desktop-integration.vala"
	result = peek_desktop_integration_xdg_current_desktop_contains ("KDE");
#line 152 "../src/desktop-integration.vala"
	return result;
#line 715 "desktop-integration.c"
}

gboolean
peek_desktop_integration_is_wayland (void)
{
	gchar* wayland_display = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gboolean _tmp2_ = FALSE;
	const gchar* _tmp3_;
	gboolean result;
#line 156 "../src/desktop-integration.vala"
	_tmp0_ = g_getenv ("WAYLAND_DISPLAY");
#line 156 "../src/desktop-integration.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 156 "../src/desktop-integration.vala"
	wayland_display = _tmp1_;
#line 157 "../src/desktop-integration.vala"
	_tmp3_ = wayland_display;
#line 157 "../src/desktop-integration.vala"
	if (_tmp3_ != NULL) {
#line 737 "desktop-integration.c"
		const gchar* _tmp4_;
#line 157 "../src/desktop-integration.vala"
		_tmp4_ = wayland_display;
#line 157 "../src/desktop-integration.vala"
		_tmp2_ = g_strcmp0 (_tmp4_, "") != 0;
#line 743 "desktop-integration.c"
	} else {
#line 157 "../src/desktop-integration.vala"
		_tmp2_ = FALSE;
#line 747 "desktop-integration.c"
	}
#line 157 "../src/desktop-integration.vala"
	result = _tmp2_;
#line 157 "../src/desktop-integration.vala"
	_g_free0 (wayland_display);
#line 157 "../src/desktop-integration.vala"
	return result;
#line 755 "desktop-integration.c"
}

gboolean
peek_desktop_integration_is_x11_backend (void)
{
	GType window_type = 0UL;
	GdkDisplayManager* _tmp0_;
	GdkDisplay* _tmp1_;
	GdkDisplay* _tmp2_;
	const gchar* _tmp3_;
	gboolean result;
#line 161 "../src/desktop-integration.vala"
	_tmp0_ = gdk_display_manager_get ();
#line 161 "../src/desktop-integration.vala"
	_tmp1_ = gdk_display_manager_get_default_display (_tmp0_);
#line 161 "../src/desktop-integration.vala"
	_tmp2_ = _tmp1_;
#line 161 "../src/desktop-integration.vala"
	window_type = G_TYPE_FROM_INSTANCE ((GObject*) _tmp2_);
#line 162 "../src/desktop-integration.vala"
	_tmp3_ = g_type_name (window_type);
#line 162 "../src/desktop-integration.vala"
	result = g_strcmp0 (_tmp3_, "GdkX11Display") == 0;
#line 162 "../src/desktop-integration.vala"
	return result;
#line 781 "desktop-integration.c"
}

gboolean
peek_desktop_integration_is_wayland_backend (void)
{
	GType window_type = 0UL;
	GdkDisplayManager* _tmp0_;
	GdkDisplay* _tmp1_;
	GdkDisplay* _tmp2_;
	const gchar* _tmp3_;
	gboolean result;
#line 166 "../src/desktop-integration.vala"
	_tmp0_ = gdk_display_manager_get ();
#line 166 "../src/desktop-integration.vala"
	_tmp1_ = gdk_display_manager_get_default_display (_tmp0_);
#line 166 "../src/desktop-integration.vala"
	_tmp2_ = _tmp1_;
#line 166 "../src/desktop-integration.vala"
	window_type = G_TYPE_FROM_INSTANCE ((GObject*) _tmp2_);
#line 167 "../src/desktop-integration.vala"
	_tmp3_ = g_type_name (window_type);
#line 167 "../src/desktop-integration.vala"
	result = g_strcmp0 (_tmp3_, "GdkWaylandDisplay") == 0;
#line 167 "../src/desktop-integration.vala"
	return result;
#line 807 "desktop-integration.c"
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1585 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1585 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1585 "glib-2.0.vapi"
	return result;
#line 826 "desktop-integration.c"
}

static gboolean
peek_desktop_integration_xdg_current_desktop_contains (const gchar* text)
{
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_;
	gchar* desktop = NULL;
	gchar* _tmp2_;
	gboolean result;
#line 170 "../src/desktop-integration.vala"
	g_return_val_if_fail (text != NULL, FALSE);
#line 171 "../src/desktop-integration.vala"
	_tmp1_ = g_getenv ("XDG_CURRENT_DESKTOP");
#line 171 "../src/desktop-integration.vala"
	_tmp0_ = _tmp1_;
#line 171 "../src/desktop-integration.vala"
	if (_tmp0_ == NULL) {
#line 171 "../src/desktop-integration.vala"
		_tmp0_ = "";
#line 847 "desktop-integration.c"
	}
#line 171 "../src/desktop-integration.vala"
	_tmp2_ = g_strdup (_tmp0_);
#line 171 "../src/desktop-integration.vala"
	desktop = _tmp2_;
#line 172 "../src/desktop-integration.vala"
	g_debug ("desktop-integration.vala:172: Desktop: %s", desktop);
#line 173 "../src/desktop-integration.vala"
	result = string_contains (desktop, text);
#line 173 "../src/desktop-integration.vala"
	_g_free0 (desktop);
#line 173 "../src/desktop-integration.vala"
	return result;
#line 861 "desktop-integration.c"
}

gchar*
peek_desktop_integration_get_theme_name (void)
{
	gchar* theme_name = NULL;
	gchar* _tmp0_;
	const gchar* _tmp2_;
	gchar* result;
#line 177 "../src/desktop-integration.vala"
	_tmp0_ = g_strdup ("");
#line 177 "../src/desktop-integration.vala"
	theme_name = _tmp0_;
#line 178 "../src/desktop-integration.vala"
	if (peek_desktop_integration_is_plasma ()) {
#line 877 "desktop-integration.c"
		gchar* _tmp1_;
#line 179 "../src/desktop-integration.vala"
		_tmp1_ = peek_desktop_integration_get_theme_name_from_settings_file ();
#line 179 "../src/desktop-integration.vala"
		_g_free0 (theme_name);
#line 179 "../src/desktop-integration.vala"
		theme_name = _tmp1_;
#line 885 "desktop-integration.c"
	}
#line 182 "../src/desktop-integration.vala"
	_tmp2_ = theme_name;
#line 182 "../src/desktop-integration.vala"
	if (g_strcmp0 (_tmp2_, "") == 0) {
#line 891 "desktop-integration.c"
		GSettings* settings = NULL;
		GSettings* _tmp3_;
		GSettings* _tmp4_;
		gchar* _tmp5_;
#line 183 "../src/desktop-integration.vala"
		_tmp3_ = g_settings_new ("org.gnome.desktop.interface");
#line 183 "../src/desktop-integration.vala"
		settings = _tmp3_;
#line 184 "../src/desktop-integration.vala"
		_tmp4_ = settings;
#line 184 "../src/desktop-integration.vala"
		_tmp5_ = g_settings_get_string (_tmp4_, "gtk-theme");
#line 184 "../src/desktop-integration.vala"
		_g_free0 (theme_name);
#line 184 "../src/desktop-integration.vala"
		theme_name = _tmp5_;
#line 182 "../src/desktop-integration.vala"
		_g_object_unref0 (settings);
#line 910 "desktop-integration.c"
	}
#line 187 "../src/desktop-integration.vala"
	result = theme_name;
#line 187 "../src/desktop-integration.vala"
	return result;
#line 916 "desktop-integration.c"
}

static gchar*
peek_desktop_integration_get_theme_name_from_settings_file (void)
{
	gchar* gtk3_settings_file = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* contents = NULL;
	gchar* _tmp19_;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 191 "../src/desktop-integration.vala"
	_tmp0_ = g_get_home_dir ();
#line 191 "../src/desktop-integration.vala"
	_tmp1_ = g_build_filename (_tmp0_, ".config/gtk-3.0/settings.ini", NULL);
#line 191 "../src/desktop-integration.vala"
	gtk3_settings_file = _tmp1_;
#line 935 "desktop-integration.c"
	{
		gboolean _tmp2_ = FALSE;
		const gchar* _tmp3_;
		gchar* _tmp4_ = NULL;
		gboolean _tmp5_;
#line 197 "../src/desktop-integration.vala"
		_tmp3_ = gtk3_settings_file;
#line 197 "../src/desktop-integration.vala"
		_tmp5_ = g_file_get_contents (_tmp3_, &_tmp4_, NULL, &_inner_error0_);
#line 197 "../src/desktop-integration.vala"
		_g_free0 (contents);
#line 197 "../src/desktop-integration.vala"
		contents = _tmp4_;
#line 197 "../src/desktop-integration.vala"
		_tmp2_ = _tmp5_;
#line 197 "../src/desktop-integration.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 197 "../src/desktop-integration.vala"
			if (_inner_error0_->domain == G_FILE_ERROR) {
#line 955 "desktop-integration.c"
				goto __catch0_g_file_error;
			}
#line 197 "../src/desktop-integration.vala"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 960 "desktop-integration.c"
				goto __catch0_g_regex_error;
			}
#line 197 "../src/desktop-integration.vala"
			_g_free0 (contents);
#line 197 "../src/desktop-integration.vala"
			_g_free0 (gtk3_settings_file);
#line 197 "../src/desktop-integration.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 197 "../src/desktop-integration.vala"
			g_clear_error (&_inner_error0_);
#line 197 "../src/desktop-integration.vala"
			return NULL;
#line 973 "desktop-integration.c"
		}
#line 197 "../src/desktop-integration.vala"
		if (_tmp2_) {
#line 977 "desktop-integration.c"
			GMatchInfo* match = NULL;
			GRegex* regex = NULL;
			GRegex* _tmp6_;
			GRegex* _tmp7_;
			const gchar* _tmp8_;
			GMatchInfo* _tmp9_ = NULL;
			gboolean _tmp10_;
#line 199 "../src/desktop-integration.vala"
			_tmp6_ = g_regex_new ("^gtk-theme-name=(.*)$", G_REGEX_MULTILINE, 0, &_inner_error0_);
#line 199 "../src/desktop-integration.vala"
			regex = _tmp6_;
#line 199 "../src/desktop-integration.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 199 "../src/desktop-integration.vala"
				_g_match_info_unref0 (match);
#line 199 "../src/desktop-integration.vala"
				if (_inner_error0_->domain == G_FILE_ERROR) {
#line 995 "desktop-integration.c"
					goto __catch0_g_file_error;
				}
#line 199 "../src/desktop-integration.vala"
				if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 1000 "desktop-integration.c"
					goto __catch0_g_regex_error;
				}
#line 199 "../src/desktop-integration.vala"
				_g_free0 (contents);
#line 199 "../src/desktop-integration.vala"
				_g_free0 (gtk3_settings_file);
#line 199 "../src/desktop-integration.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 199 "../src/desktop-integration.vala"
				g_clear_error (&_inner_error0_);
#line 199 "../src/desktop-integration.vala"
				return NULL;
#line 1013 "desktop-integration.c"
			}
#line 200 "../src/desktop-integration.vala"
			_tmp7_ = regex;
#line 200 "../src/desktop-integration.vala"
			_tmp8_ = contents;
#line 200 "../src/desktop-integration.vala"
			_tmp10_ = g_regex_match (_tmp7_, _tmp8_, 0, &_tmp9_);
#line 200 "../src/desktop-integration.vala"
			_g_match_info_unref0 (match);
#line 200 "../src/desktop-integration.vala"
			match = _tmp9_;
#line 200 "../src/desktop-integration.vala"
			if (_tmp10_) {
#line 1027 "desktop-integration.c"
				GMatchInfo* _tmp11_;
				gchar* _tmp12_;
#line 201 "../src/desktop-integration.vala"
				_tmp11_ = match;
#line 201 "../src/desktop-integration.vala"
				_tmp12_ = g_match_info_fetch (_tmp11_, 1);
#line 201 "../src/desktop-integration.vala"
				result = _tmp12_;
#line 201 "../src/desktop-integration.vala"
				_g_regex_unref0 (regex);
#line 201 "../src/desktop-integration.vala"
				_g_match_info_unref0 (match);
#line 201 "../src/desktop-integration.vala"
				_g_free0 (contents);
#line 201 "../src/desktop-integration.vala"
				_g_free0 (gtk3_settings_file);
#line 201 "../src/desktop-integration.vala"
				return result;
#line 1046 "desktop-integration.c"
			}
#line 197 "../src/desktop-integration.vala"
			_g_regex_unref0 (regex);
#line 197 "../src/desktop-integration.vala"
			_g_match_info_unref0 (match);
#line 1052 "desktop-integration.c"
		}
	}
	goto __finally0;
	__catch0_g_file_error:
	{
		GError* e = NULL;
		FILE* _tmp13_;
		GError* _tmp14_;
		const gchar* _tmp15_;
#line 196 "../src/desktop-integration.vala"
		e = _inner_error0_;
#line 196 "../src/desktop-integration.vala"
		_inner_error0_ = NULL;
#line 205 "../src/desktop-integration.vala"
		_tmp13_ = stderr;
#line 205 "../src/desktop-integration.vala"
		_tmp14_ = e;
#line 205 "../src/desktop-integration.vala"
		_tmp15_ = _tmp14_->message;
#line 205 "../src/desktop-integration.vala"
		fprintf (_tmp13_, "Error: %s\n", _tmp15_);
#line 196 "../src/desktop-integration.vala"
		_g_error_free0 (e);
#line 1076 "desktop-integration.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
		GError* e = NULL;
		FILE* _tmp16_;
		GError* _tmp17_;
		const gchar* _tmp18_;
#line 196 "../src/desktop-integration.vala"
		e = _inner_error0_;
#line 196 "../src/desktop-integration.vala"
		_inner_error0_ = NULL;
#line 207 "../src/desktop-integration.vala"
		_tmp16_ = stderr;
#line 207 "../src/desktop-integration.vala"
		_tmp17_ = e;
#line 207 "../src/desktop-integration.vala"
		_tmp18_ = _tmp17_->message;
#line 207 "../src/desktop-integration.vala"
		fprintf (_tmp16_, "Error: %s\n", _tmp18_);
#line 196 "../src/desktop-integration.vala"
		_g_error_free0 (e);
#line 1099 "desktop-integration.c"
	}
	__finally0:
#line 196 "../src/desktop-integration.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 196 "../src/desktop-integration.vala"
		_g_free0 (contents);
#line 196 "../src/desktop-integration.vala"
		_g_free0 (gtk3_settings_file);
#line 196 "../src/desktop-integration.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 196 "../src/desktop-integration.vala"
		g_clear_error (&_inner_error0_);
#line 196 "../src/desktop-integration.vala"
		return NULL;
#line 1114 "desktop-integration.c"
	}
#line 210 "../src/desktop-integration.vala"
	_tmp19_ = g_strdup ("");
#line 210 "../src/desktop-integration.vala"
	result = _tmp19_;
#line 210 "../src/desktop-integration.vala"
	_g_free0 (contents);
#line 210 "../src/desktop-integration.vala"
	_g_free0 (gtk3_settings_file);
#line 210 "../src/desktop-integration.vala"
	return result;
#line 1126 "desktop-integration.c"
}

static gboolean
peek_desktop_integration_file_manager_highlights_file (GAppInfo* app_info)
{
	gchar* exe = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gboolean _tmp2_ = FALSE;
	const gchar* _tmp3_;
	gboolean result;
#line 214 "../src/desktop-integration.vala"
	g_return_val_if_fail (app_info != NULL, FALSE);
#line 215 "../src/desktop-integration.vala"
	_tmp0_ = g_app_info_get_executable (app_info);
#line 215 "../src/desktop-integration.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 215 "../src/desktop-integration.vala"
	exe = _tmp1_;
#line 216 "../src/desktop-integration.vala"
	_tmp3_ = exe;
#line 216 "../src/desktop-integration.vala"
	if (g_strcmp0 (_tmp3_, "nautilus") == 0) {
#line 216 "../src/desktop-integration.vala"
		_tmp2_ = TRUE;
#line 1152 "desktop-integration.c"
	} else {
		const gchar* _tmp4_;
#line 216 "../src/desktop-integration.vala"
		_tmp4_ = exe;
#line 216 "../src/desktop-integration.vala"
		_tmp2_ = g_strcmp0 (_tmp4_, "nemo") == 0;
#line 1159 "desktop-integration.c"
	}
#line 216 "../src/desktop-integration.vala"
	result = _tmp2_;
#line 216 "../src/desktop-integration.vala"
	_g_free0 (exe);
#line 216 "../src/desktop-integration.vala"
	return result;
#line 1167 "desktop-integration.c"
}

PeekDesktopIntegration*
peek_desktop_integration_construct (GType object_type)
{
	PeekDesktopIntegration* self = NULL;
#line 12 "../src/desktop-integration.vala"
	self = (PeekDesktopIntegration*) g_type_create_instance (object_type);
#line 12 "../src/desktop-integration.vala"
	return self;
#line 1178 "desktop-integration.c"
}

PeekDesktopIntegration*
peek_desktop_integration_new (void)
{
#line 12 "../src/desktop-integration.vala"
	return peek_desktop_integration_construct (PEEK_TYPE_DESKTOP_INTEGRATION);
#line 1186 "desktop-integration.c"
}

static FreedesktopFileManager1*
peek_desktop_integration_get_file_manager_service (void)
{
	FreedesktopFileManager1* result;
	FreedesktopFileManager1* _tmp5_;
	GError* _inner_error0_ = NULL;
#line 19 "../src/desktop-integration.vala"
	if (!peek_desktop_integration__file_manager_dbus_initialized) {
#line 1197 "desktop-integration.c"
		{
			FreedesktopFileManager1* _tmp0_ = NULL;
			FreedesktopFileManager1* _tmp1_;
			FreedesktopFileManager1* _tmp2_;
#line 21 "../src/desktop-integration.vala"
			_tmp1_ = (FreedesktopFileManager1*) g_initable_new (FREEDESKTOP_TYPE_FILE_MANAGER1_PROXY, NULL, &_inner_error0_, "g-flags", 0, "g-name", "org.freedesktop.FileManager1", "g-bus-type", G_BUS_TYPE_SESSION, "g-object-path", "/org/freedesktop/FileManager1", "g-interface-name", "org.freedesktop.FileManager1", NULL);
#line 21 "../src/desktop-integration.vala"
			_tmp0_ = (FreedesktopFileManager1*) _tmp1_;
#line 21 "../src/desktop-integration.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 21 "../src/desktop-integration.vala"
				if (_inner_error0_->domain == G_IO_ERROR) {
#line 1210 "desktop-integration.c"
					goto __catch0_g_io_error;
				}
#line 21 "../src/desktop-integration.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 21 "../src/desktop-integration.vala"
				g_clear_error (&_inner_error0_);
#line 21 "../src/desktop-integration.vala"
				return NULL;
#line 1219 "desktop-integration.c"
			}
#line 21 "../src/desktop-integration.vala"
			_tmp2_ = _tmp0_;
#line 21 "../src/desktop-integration.vala"
			_tmp0_ = NULL;
#line 21 "../src/desktop-integration.vala"
			_g_object_unref0 (peek_desktop_integration__file_manager_service);
#line 21 "../src/desktop-integration.vala"
			peek_desktop_integration__file_manager_service = _tmp2_;
#line 20 "../src/desktop-integration.vala"
			_g_object_unref0 (_tmp0_);
#line 1231 "desktop-integration.c"
		}
		goto __finally0;
		__catch0_g_io_error:
		{
			GError* e = NULL;
			GError* _tmp3_;
			const gchar* _tmp4_;
#line 20 "../src/desktop-integration.vala"
			e = _inner_error0_;
#line 20 "../src/desktop-integration.vala"
			_inner_error0_ = NULL;
#line 26 "../src/desktop-integration.vala"
			_tmp3_ = e;
#line 26 "../src/desktop-integration.vala"
			_tmp4_ = _tmp3_->message;
#line 26 "../src/desktop-integration.vala"
			g_debug ("desktop-integration.vala:26: DBus service org.freedesktop.FileManager1" \
" not available: %s\n", _tmp4_);
#line 27 "../src/desktop-integration.vala"
			_g_object_unref0 (peek_desktop_integration__file_manager_service);
#line 27 "../src/desktop-integration.vala"
			peek_desktop_integration__file_manager_service = NULL;
#line 20 "../src/desktop-integration.vala"
			_g_error_free0 (e);
#line 1255 "desktop-integration.c"
		}
		__finally0:
		{
			GError* _inner_error1_ = NULL;
#line 29 "../src/desktop-integration.vala"
			peek_desktop_integration__file_manager_dbus_initialized = TRUE;
#line 1262 "desktop-integration.c"
		}
#line 20 "../src/desktop-integration.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 20 "../src/desktop-integration.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 20 "../src/desktop-integration.vala"
			g_clear_error (&_inner_error0_);
#line 20 "../src/desktop-integration.vala"
			return NULL;
#line 1272 "desktop-integration.c"
		}
	}
#line 33 "../src/desktop-integration.vala"
	_tmp5_ = peek_desktop_integration__file_manager_service;
#line 33 "../src/desktop-integration.vala"
	result = _tmp5_;
#line 33 "../src/desktop-integration.vala"
	return result;
#line 1281 "desktop-integration.c"
}

static void
peek_value_desktop_integration_init (GValue* value)
{
#line 12 "../src/desktop-integration.vala"
	value->data[0].v_pointer = NULL;
#line 1289 "desktop-integration.c"
}

static void
peek_value_desktop_integration_free_value (GValue* value)
{
#line 12 "../src/desktop-integration.vala"
	if (value->data[0].v_pointer) {
#line 12 "../src/desktop-integration.vala"
		peek_desktop_integration_unref (value->data[0].v_pointer);
#line 1299 "desktop-integration.c"
	}
}

static void
peek_value_desktop_integration_copy_value (const GValue* src_value,
                                           GValue* dest_value)
{
#line 12 "../src/desktop-integration.vala"
	if (src_value->data[0].v_pointer) {
#line 12 "../src/desktop-integration.vala"
		dest_value->data[0].v_pointer = peek_desktop_integration_ref (src_value->data[0].v_pointer);
#line 1311 "desktop-integration.c"
	} else {
#line 12 "../src/desktop-integration.vala"
		dest_value->data[0].v_pointer = NULL;
#line 1315 "desktop-integration.c"
	}
}

static gpointer
peek_value_desktop_integration_peek_pointer (const GValue* value)
{
#line 12 "../src/desktop-integration.vala"
	return value->data[0].v_pointer;
#line 1324 "desktop-integration.c"
}

static gchar*
peek_value_desktop_integration_collect_value (GValue* value,
                                              guint n_collect_values,
                                              GTypeCValue* collect_values,
                                              guint collect_flags)
{
#line 12 "../src/desktop-integration.vala"
	if (collect_values[0].v_pointer) {
#line 1335 "desktop-integration.c"
		PeekDesktopIntegration * object;
		object = collect_values[0].v_pointer;
#line 12 "../src/desktop-integration.vala"
		if (object->parent_instance.g_class == NULL) {
#line 12 "../src/desktop-integration.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1342 "desktop-integration.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 12 "../src/desktop-integration.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1346 "desktop-integration.c"
		}
#line 12 "../src/desktop-integration.vala"
		value->data[0].v_pointer = peek_desktop_integration_ref (object);
#line 1350 "desktop-integration.c"
	} else {
#line 12 "../src/desktop-integration.vala"
		value->data[0].v_pointer = NULL;
#line 1354 "desktop-integration.c"
	}
#line 12 "../src/desktop-integration.vala"
	return NULL;
#line 1358 "desktop-integration.c"
}

static gchar*
peek_value_desktop_integration_lcopy_value (const GValue* value,
                                            guint n_collect_values,
                                            GTypeCValue* collect_values,
                                            guint collect_flags)
{
	PeekDesktopIntegration ** object_p;
	object_p = collect_values[0].v_pointer;
#line 12 "../src/desktop-integration.vala"
	if (!object_p) {
#line 12 "../src/desktop-integration.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 1373 "desktop-integration.c"
	}
#line 12 "../src/desktop-integration.vala"
	if (!value->data[0].v_pointer) {
#line 12 "../src/desktop-integration.vala"
		*object_p = NULL;
#line 1379 "desktop-integration.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 12 "../src/desktop-integration.vala"
		*object_p = value->data[0].v_pointer;
#line 1383 "desktop-integration.c"
	} else {
#line 12 "../src/desktop-integration.vala"
		*object_p = peek_desktop_integration_ref (value->data[0].v_pointer);
#line 1387 "desktop-integration.c"
	}
#line 12 "../src/desktop-integration.vala"
	return NULL;
#line 1391 "desktop-integration.c"
}

GParamSpec*
peek_param_spec_desktop_integration (const gchar* name,
                                     const gchar* nick,
                                     const gchar* blurb,
                                     GType object_type,
                                     GParamFlags flags)
{
	PeekParamSpecDesktopIntegration* spec;
#line 12 "../src/desktop-integration.vala"
	g_return_val_if_fail (g_type_is_a (object_type, PEEK_TYPE_DESKTOP_INTEGRATION), NULL);
#line 12 "../src/desktop-integration.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 12 "../src/desktop-integration.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 12 "../src/desktop-integration.vala"
	return G_PARAM_SPEC (spec);
#line 1410 "desktop-integration.c"
}

gpointer
peek_value_get_desktop_integration (const GValue* value)
{
#line 12 "../src/desktop-integration.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PEEK_TYPE_DESKTOP_INTEGRATION), NULL);
#line 12 "../src/desktop-integration.vala"
	return value->data[0].v_pointer;
#line 1420 "desktop-integration.c"
}

void
peek_value_set_desktop_integration (GValue* value,
                                    gpointer v_object)
{
	PeekDesktopIntegration * old;
#line 12 "../src/desktop-integration.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PEEK_TYPE_DESKTOP_INTEGRATION));
#line 12 "../src/desktop-integration.vala"
	old = value->data[0].v_pointer;
#line 12 "../src/desktop-integration.vala"
	if (v_object) {
#line 12 "../src/desktop-integration.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PEEK_TYPE_DESKTOP_INTEGRATION));
#line 12 "../src/desktop-integration.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 12 "../src/desktop-integration.vala"
		value->data[0].v_pointer = v_object;
#line 12 "../src/desktop-integration.vala"
		peek_desktop_integration_ref (value->data[0].v_pointer);
#line 1442 "desktop-integration.c"
	} else {
#line 12 "../src/desktop-integration.vala"
		value->data[0].v_pointer = NULL;
#line 1446 "desktop-integration.c"
	}
#line 12 "../src/desktop-integration.vala"
	if (old) {
#line 12 "../src/desktop-integration.vala"
		peek_desktop_integration_unref (old);
#line 1452 "desktop-integration.c"
	}
}

void
peek_value_take_desktop_integration (GValue* value,
                                     gpointer v_object)
{
	PeekDesktopIntegration * old;
#line 12 "../src/desktop-integration.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PEEK_TYPE_DESKTOP_INTEGRATION));
#line 12 "../src/desktop-integration.vala"
	old = value->data[0].v_pointer;
#line 12 "../src/desktop-integration.vala"
	if (v_object) {
#line 12 "../src/desktop-integration.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PEEK_TYPE_DESKTOP_INTEGRATION));
#line 12 "../src/desktop-integration.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 12 "../src/desktop-integration.vala"
		value->data[0].v_pointer = v_object;
#line 1473 "desktop-integration.c"
	} else {
#line 12 "../src/desktop-integration.vala"
		value->data[0].v_pointer = NULL;
#line 1477 "desktop-integration.c"
	}
#line 12 "../src/desktop-integration.vala"
	if (old) {
#line 12 "../src/desktop-integration.vala"
		peek_desktop_integration_unref (old);
#line 1483 "desktop-integration.c"
	}
}

static void
peek_desktop_integration_class_init (PeekDesktopIntegrationClass * klass,
                                     gpointer klass_data)
{
#line 12 "../src/desktop-integration.vala"
	peek_desktop_integration_parent_class = g_type_class_peek_parent (klass);
#line 12 "../src/desktop-integration.vala"
	((PeekDesktopIntegrationClass *) klass)->finalize = peek_desktop_integration_finalize;
#line 1495 "desktop-integration.c"
}

static void
peek_desktop_integration_instance_init (PeekDesktopIntegration * self,
                                        gpointer klass)
{
#line 12 "../src/desktop-integration.vala"
	self->ref_count = 1;
#line 1504 "desktop-integration.c"
}

static void
peek_desktop_integration_finalize (PeekDesktopIntegration * obj)
{
	PeekDesktopIntegration * self;
#line 12 "../src/desktop-integration.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PEEK_TYPE_DESKTOP_INTEGRATION, PeekDesktopIntegration);
#line 12 "../src/desktop-integration.vala"
	g_signal_handlers_destroy (self);
#line 1515 "desktop-integration.c"
}

static GType
peek_desktop_integration_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { peek_value_desktop_integration_init, peek_value_desktop_integration_free_value, peek_value_desktop_integration_copy_value, peek_value_desktop_integration_peek_pointer, "p", peek_value_desktop_integration_collect_value, "p", peek_value_desktop_integration_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (PeekDesktopIntegrationClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) peek_desktop_integration_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PeekDesktopIntegration), 0, (GInstanceInitFunc) peek_desktop_integration_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType peek_desktop_integration_type_id;
	peek_desktop_integration_type_id = g_type_register_fundamental (g_type_fundamental_next (), "PeekDesktopIntegration", &g_define_type_info, &g_define_type_fundamental_info, 0);
	return peek_desktop_integration_type_id;
}

GType
peek_desktop_integration_get_type (void)
{
	static volatile gsize peek_desktop_integration_type_id__once = 0;
	if (g_once_init_enter (&peek_desktop_integration_type_id__once)) {
		GType peek_desktop_integration_type_id;
		peek_desktop_integration_type_id = peek_desktop_integration_get_type_once ();
		g_once_init_leave (&peek_desktop_integration_type_id__once, peek_desktop_integration_type_id);
	}
	return peek_desktop_integration_type_id__once;
}

gpointer
peek_desktop_integration_ref (gpointer instance)
{
	PeekDesktopIntegration * self;
	self = instance;
#line 12 "../src/desktop-integration.vala"
	g_atomic_int_inc (&self->ref_count);
#line 12 "../src/desktop-integration.vala"
	return instance;
#line 1550 "desktop-integration.c"
}

void
peek_desktop_integration_unref (gpointer instance)
{
	PeekDesktopIntegration * self;
	self = instance;
#line 12 "../src/desktop-integration.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 12 "../src/desktop-integration.vala"
		PEEK_DESKTOP_INTEGRATION_GET_CLASS (self)->finalize (self);
#line 12 "../src/desktop-integration.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 1564 "desktop-integration.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

